	TITLE	'MHATS -- MINISCRIBE  MS-3012 ALTERNATE TRACK SEEK TEST'

;	04-19-83



;   This program tests the seek logic of an XCOMP STS/STR Hard Disk
;   Controller. The program also ensures that the disk drive will
;   seek properly.
;
;
;   NOTE -- Hitting the ESC key will abort testing.






;	---PROGRAM CONFIGURATION---
;
;
;   THE FOLLOWING STATEMENTS ARE USED TO CONFIGURE THE PROGRAM.
;
;	1. TEST - SET THIS 'FALSE' BEFORE USING THE PROGRAM.
;
;	2. S100 - SET THIS 'TRUE' IF YOU ARE USING A CONTROLLER WITH
;	   AN S-100 BUS INTERFACE (SGS). SET THIS 'FALSE' IF YOU
;	   ARE USING A CONTROLLER WITH A RIBBON CABLE INTERFACE
;	   (SGR).
;
;
FALSE	EQU	0		;DEFINE FALSE
TRUE	EQU	NOT FALSE	;..TRUE
;
TEST	EQU	FALSE		;NOT TESTING
;
S100	EQU	TRUE		;S-100 CONTROLLER





;	---EQUATES---
;
;
STRT	EQU	100H		;PROGRAM START ADDRESS
STACK	EQU	100H		;STACK POINTER
WBOOT	EQU	0		;CPM WARM BOOT
BDOS	EQU	5		;BDOS ENTRY POINT
DEBUG	EQU	0F000H		;DEBUG ENTRY POINT
DR0	EQU	41H		;DRIVE 0, HEAD 0
LZONE	EQU	656		;LANDING ZONE
;
;   DRIVE COMMANDS
;
STEPIN	EQU	3		;STEP DIRECTION = INWARD
STEPOUT	EQU	1		;  * OUTWARD
SKCMD	EQU	3		;SEEK COMMAND
;
;   DRIVE STATUS
;
READY	EQU	1		;DRIVE READY
WRTFLT	EQU	2		;WRITE FAULT
TK00	EQU	4		;TRACK ZERO
;
;   DRIVE/CONTROLLER I/O
;
	IF	S100	; IF S-100 BUS INTERFACE
CBASE	EQU	70H		;BASE ADR OF THE CONTROLLER
DRCSR	EQU	CBASE		;DRIVE COMMAND/STATUS
EXTCMD	EQU	CBASE+1		;EXTENDED COMMNAND REGISTER
LOSC	EQU	CBASE+2		;SEEK COUNT, LSB
HISC	EQU	CBASE+3		;  * MSB
CTCSR	EQU	CBASE+4		;CONTROLLER COMMAND/STATUS
CTBFR	EQU	CBASE+5		;CONTROLLER BUFFER ADDRESS
CTDP	EQU	CBASE+6		;CONTROLLER DATA PORT
	ELSE		; IF RIBBON CABLE INTERFACE
CBASE	EQU	80H		;BASE ADR OF THE CONTROLLER
DRCSR	EQU	CBASE+7		;DRIVE COMMAND/STATUS
EXTCMD	EQU	CBASE+6		;EXTENDED COMMNAND REGISTER
LOSC	EQU	CBASE+5		;SEEK COUNT, LSB
HISC	EQU	CBASE+4		;  * MSB
CTCSR	EQU	CBASE+3		;CONTROLLER COMMAND/STATUS
CTBFR	EQU	CBASE+2		;CONTROLLER BUFFER ADDRESS
CTDP	EQU	CBASE+1		;CONTROLLER DATA PORT
	ENDIF
;
;   ASCII CHARACTERS 
;
CR	EQU	0DH		;CARRIAGE RETURN
LF	EQU	0AH		;LINE FEED
BELL	EQU	7		;DING!
ESC	EQU	1BH		;ESCAPE KEY
;
;   CPM FUNCTION CODES
;
F@CI	EQU	1		;CONSOLE INPUT
F@CO	EQU	2		;CONSOLE OUTPUT
F@PRNT	EQU	9		;PRINT MESSAGES
F@RCB	EQU	10		;READ CONSOLE BUFFER
F@REQ	EQU	11		;GET CONSOLE STATUS

	PAGE



;	============
;	** MACROS **
;	============



;	---CALL BDOS---
;
;
CPM	MACRO	FC
	CALL	SYSTEM		;; SYSTEM CALL ROUTINE
	DB	FC		;; CPM FUNCTION CODE
	ENDM




;	---PRINT MESSAGES---
;
;
PRNT	MACRO	MSG
	LXI	D,MSG		;; ADR OF THE MSG
	CPM	F@PRNT		;; PRINT THE MSG
	ENDM

	PAGE

	ORG	STRT



;	---PROGRAM ENTRY POINT---
;
;
BGN:	LXI	SP,$
	CALL	COFF		;STOP ANY PRIOR ACTIVITY
	PRNT	MSG1		;SAY HELLO
	MVI	A,1
	OUT	EXTCMD		;SELECT THE DRIVE
	INR	A
	OUT	DRCSR		;ENABLE THE INTERFACE
;
;   COMMAND LOOP
;
LOOP:	LXI	SP,STRT		;RESET THE STACK POINTER
	PRNT	MSG2		;PRINT THE MENU
	CALL	GCMD		;GET OPER CMD
	MVI	B,0
	CPI	'S'
	JZ	ATS		;JIF DO SINGLE PASS
	INR	B
	CPI	'C'
	JZ	ATS		;JIF DO CONTINUOUS TESTING
	CPI	'X'
	JZ	XIT		;JIF EXIT TO CPM
	PRNT	MSG3		; 'INVALID INPUT'
	JMP	LOOP		;TRY AGAIN
;
;   EXIT TO CPM
;
XIT:	CALL	CRLF		;DO CR.LF
	CALL	COFF		;TURN OFF DRIVE/CTLR
	IF	TEST
	JMP	DEBUG
	ELSE
	JMP	WBOOT
	ENDIF

	PAGE

;	===============
;	** TEST CODE **
;	===============




;	---SEEK TEST---
;
;
ATS:	MOV	A,B
	STA	MODE		;SAVE MODE INDICATOR
	CALL	CRLF		;DO CR.LF
	CALL	TKZ		;RESTORE
;
ATS1:	LXI	H,TABLE		;TRACK ADDRESS TBALE
;
ATS2:	MOV	E,M		;CYL ADR, LSB
	INX	H
	MOV	D,M		;  * MSB
	INX	H
	SHLD	TBLADR		;SAVE TABLE ADR
	MOV	A,D
	ORA	E
	JZ	ATS3		;JIF TESTING DONE
	XCHG
	SHLD	CYL		;SAVE TARGET CYL ADR
	PRNT	MSG5		; 'SEEK'
	LHLD	CYL
	CALL	P4D		;PRINT TARGET CYL ADR
	CALL	SEEK		;SEEK TO TARGET CYL
	CALL	TKZ		;RESTORE
	LHLD	COUNT
	XCHG	
	LXI	H,LZONE
	CALL	SUBT		;CALC # CYLS STEPPED
	SHLD	COUNT		;SAVE IN CASE OF ERRORS
	XCHG
	LHLD	CYL
	CALL	SUBT		;DID WE SEEK OK ?
	JNZ	SKERR		;NO, ABORT TEST
	PRNT	MSG7		; 'OK'
	LHLD	TBLADR
	JMP	ATS2		;CON'T TEST
;
ATS3:	LDA	MODE		;GET MODE INDICATOR
	ORA	A
	JZ	DONE		;JIF DOING SINGLE PASS
	PRNT	MSG11		; 'PASS FINISHED'
	JMP	ATS1		;DO NEXT PASS




;	---TEST DONE---
;
;
DONE:	PRNT	MSG4		; 'TEST DONE'
	JMP	LOOP		;DO NEXT CMD




;	---SEEK ERROR---
;
;
SKERR:	PRNT	MSG6		; 'FAILED...'
	LHLD	COUNT
	CALL	P4D		;PRINT SEEK COUNT AT FAILURE
	CALL	CRLF		;DO CR.LF
	JMP	LOOP		;GO BACK TO CMD LOOP

	PAGE

;	===================
;	** DISK ROUTINES **
;	===================



;	---REZERO---
;
;
TKZ:	LXI	H,0
	SHLD	CCA		;INIT CURR CYL ADR
	LXI	H,LZONE
	SHLD	COUNT		;INIT SEEK COUNT
;
TKZ1:	CALL	RDY		;DRIVE READY ?  (RIF YES)
	IN	DRCSR		;DRIVE STATUS
	ANI	TK00		;TRACK ZERO INDICATOR
	RNZ			;RIF AT TRACK ZERO
	CALL	STOP		;STOP TESTING ?  (RIF NO)
	LHLD	COUNT
	DCX	H		;DECR SEEK COUNT
	SHLD	COUNT
	MOV	A,H
	ORA	L
	JZ	TKZ2		;JIF RESTORE FAILED
	XRA	A
	OUT	HISC
	INR	A
	OUT	LOSC		;SET SEEK COUNT = 1
	OUT	EXTCMD		;SET DIRECTION = OUTWARD
	MVI	A,SKCMD
	OUT	DRCSR		;ISSUE SEEK CMD
	CALL	WSC		;WAIT FOR SEEK DONE
	JMP	TKZ1
;
TKZ2:	PRNT	MSG8		; 'REZERO FAILED'
	JMP	LOOP		;ABORT




;	---SEEK---
;
;
SEEK:	CALL	RDY		;DRIVE READY ?  (RIF YES)
	LHLD	CCA		;CURR CYL ADR
	XCHG
	LHLD	CYL		;NEW CYL ADR
	SHLD	CCA		;..UPDATE OLD
	XCHG
	CALL	SUBT		; (OLD CYL) - (NEW CYL)
	RZ			;DON'T SEEK IF SAME CYL
	JNC	SEK1		;JIF SEEK OUTWARD
; SEEK INWARD
	XCHG
	LXI	H,0
	CALL	SUBT		;MAKE SEEK COUNT POSITIVE
	MVI	A,STEPIN	;STEP DIRECTION = INWARD
	JMP	SEK2
; SEEK OUTWARD
SEK1:	MVI	A,STEPOUT	;STEP DIRECTION = OUTWARD
;
SEK2:	OUT	EXTCMD		;SET STEP DIRECTION
	MOV	A,L
	OUT	LOSC		;SET SEEK COUNT, LSB
	MOV	A,H
	OUT	HISC		;  * SET MSB
	MVI	A,SKCMD
	OUT	DRCSR		;ISSUE SEEK CMD
;  * FALL THRU TO 'WSC' & THEN EXIT




;	---WAIT FOR SEEK COMPLETE---
;
;
WSC:	IN	DRCSR		;DRIVE STATUS
	RAL
	JNC	WSC		;WAIT FOR SEEK DONE
	RAR
	RET




;	---DRIVE READY TEST---
;
;
RDY:	IN	DRCSR		;DRIVE STATUS
	RRC
	RC			;RIF DRIVE READY
	PRNT	MSG9		; 'DRIVE NOT READY'
	JMP	LOOP		;DO NEXT CMD

	PAGE

;	---CALL CPM---
;
;   USED TO GO TO CPM (VIA BDOS) TO PERFORM NON-DISK
;   I/O. ALL REGISTERS (EXCEPT 'A') ARE SAVED & THEN
;   RESTORED AFTER THE FUNCTION IS COMPLETE. THE
;   CALLING SEQUENCE IS ---
;
;	CALL	SYSTEM		;ENTRY POINT
;	DB	FC		;FUNCTION CODE
;
;
SYSTEM:	XTHL			;H/L = ADR OF F.C.
	PUSH	D		;SAVE REGS
	PUSH	B
	MOV	C,M		;C = FUNCTION CODE
	INX	H		;H/L = RETURN ADR
	PUSH	H		;  SAVE IT
	CALL	BDOS		;DO CPM FUNCTION
	POP	H		;RESTORE RETURN ADR
	POP	B		;RESTORE REGS
	POP	D
	XTHL			;STACK = RET ADR
	ORA	A		;SET 8080 FLAGS
	RET




;	---GET OPERATOR COMMAND---
;
;
GCMD:	MVI	B,0		;INIT CMD CHAR
;
GCMD1:	CPM	F@CI		;GET OPER INPUT
	CPI	CR	
	JZ	GCMD2		;JIF CHAR WAS A 'CR'
	MOV	B,A		;SAVE CMD CHAR
	JMP	GCMD1		;WAIT FOR CR
; CONVERT L/C CHARS TO U/C
GCMD2:	MOV	A,B
	ANI	7FH		;KILL PARITY BIT
	CPI	61H
	RC			;RIF NOT L/C CHAR
	CPI	7BH
	RNC			;RIF NOT L/C CHAR
	SUI	20H		;CONVERT L/C TO U/C
	RET




;	---16 BIT SUBTRACTION---
;
;	(H/L) - (D/E)
;
;
SUBT:	MOV	A,L
	SUB	E		;SUB LSB
	MOV	L,A
	MOV	A,H
	SBB	D		;SUB MSB
	MOV	H,A
	ORA	L
	RZ			;RIF RESULTS = ZERO
	MOV	A,H
	RLC			;SET/CLEAR CY BIT
	RNZ
	INR	A		;TO MAINTAIN NON-ZERO STATUS
	RET




;	---STOP TEST---
;
;   TEST FOR THE "ESC" KEY. IF FOUND, ABORT FUNCTION.
;
;
STOP:	CPM	F@REQ		;GET CONSOLE STATUS
	RZ			;RIF DATA NOT AVAIL
	CPM	F@CI		;GET INPUT CHAR
	ANI	7FH		;KILL PARITY BIT
	CPI	ESC		;ESC KEY ?
	RNZ			;NO, EXIT
	PRNT	MSG10		; 'TEST ABORTED'
	JMP	LOOP		;ABORT, DO NEXT CMD




;	---PRINT FOUR DIGITS---
;
;
P4D:	MOV	A,H
	CALL	BTH		;PRINT TARGET CYL ADR, MSB
	MOV	A,L		;DO LSB
; FALL THRU TO 'BTH'




;	---BINARY/HEX CONVERSION---
;
;   CONVERTS BINARY DATA (IN 'A') TO 2 ASCII
;   HEX CHARACTERS & PRINTS THOSE CHARACTERS.
;
;
BTH:	PUSH	D		;SAVE D/E
	PUSH	PSW
	RRC			;MOVE MSD TO LSD
	RRC
	RRC
	RRC
	CALL	BTH1		;CONVERT MSD & PRINT IT
	POP	PSW
	CALL	BTH1		;  * LSD
	POP	D		;RESTORE D/E
	RET
;
BTH1:	ANI	0FH		;KILL MSD
	ADI	'0'
	CPI	'9'+1
	JC	BTH2		;JIF CHAR 0-9
	ADI	7		;CHAR A-F
BTH2:	MOV	E,A
	CPM	F@CO		;PRINT THE DIGIT
	RET




;	---CARRIAGE RETURN, LINE FEED---
;
;
CRLF:	PUSH	D		;SAVE D/E
	MVI	E,CR
	CPM	F@CO
	MVI	E,LF
	CPM	F@CO
	POP	D		;RESTORE D/E
	RET




;	---TURN DRIVE/CONTROLLER OFF---
;
;
COFF:	XRA	A
	OUT	CTCSR		;STOP CTLR
	OUT	DRCSR		;DISABLE THE INTERFACE
	OUT	EXTCMD		;DE-SELECT THE DRIVE
	RET




;	---SEEK TABLE---
;
;
TABLE:	DW	1,2,4,8,10H,20H,40H,80H,100H,0




;	---MESSAGES---
;
;
MSG1:	DB	CR,LF,LF,LF
	DB	'MHATS -- Vers 1.0',CR,LF
	DB	'19-Apr-83',CR,LF,'$'
;
MSG2:	DB	CR,LF,LF,LF
	DB	'Select one of the following Options ---',CR,LF,LF
	DB	'  S - Single pass',CR,LF
	DB	'  C - Continuous testing',CR,LF
	DB	'  X - Exit to CPM',CR,LF,LF
	DB	'Option? $'
;
MSG3:	DB	BELL,CR,LF,LF
	DB	'* Invalid Input'
	DB	CR,LF,'$'
;
MSG4:	DB	CR,LF,LF
	DB	'Testing Finished'
	DB	CR,LF,'$'
;
MSG5:	DB	CR,LF,'Seek $'
;
MSG6:	DB	BELL,' Failed    Count=$'
;
MSG7:	DB	' OK',CR,LF,'$'
;
MSG8:	DB	BELL,CR,LF,LF
	DB	'* Can''t find Track Zero'
	DB	CR,LF,'$'
;
MSG9:	DB	BELL,CR,LF,LF
	DB	'* Drive not Ready'
	DB	CR,LF,'$'
;
MSG10:	DB	BELL,CR,LF,LF
	DB	'* Test Aborted'
	DB	CR,LF,'$'
;
MSG11:	DB	CR,LF,LF
	DB	'Pass Finished'
	DB	CR,LF,'$'




;	---STORAGE---
;
;
COUNT:	DS	2		;RESTORE COUNT
TBLADR:	DS	2		;SEEK TABLE ADDRESS
CCA:	DS	2		;CURRENT CYLINDER ADDRESS
CYL:	DS	2		;TARGET CYLINDER ADDRESS
MODE:	DS	1		;MODE INDICATOR



	END
