	TITLE	'MHFMT -- MINISCRIBE MS-3012 FORMATTER'

;	04-12-83	** B **




;   'MHFMT' is used to format a MiniScribe MS-3012 hard disk
;   drive. An XCOMP STS/STR hard disk controller is used.
;
;
;   NOTE -- Hitting the ESC key will abort any function
;	    currently in progress.







;	---PROGRAM CONFIGURATION---
;
;
;   THESE STATEMENTS ARE USED TO CONFIGURE THE PROGRAM.
;
;	1. TEST -- SET THIS 'FALSE' BEFORE USING THE PROGRAM. 
;
;	2. S100 -- SET THIS 'TRUE' IF YOU ARE USING A CONTROLLER WITH
;	   AN S-100 BUS INTERFACE (STS). SET THIS 'FALSE' IF YOU ARE
;	   USING A CONTROLLER WITH THE RIBBON CABLE INTERFACE (STR).
;
;	3. FASTCPU -- SET THIS 'TRUE' IF YOUR PROCESSOR IS RUNNING AT
;	   4 MHZ. SET THIS 'FALSE' IF YOUR PROCESSOR IS RUNNING AT
;	   2 MHZ.
;
;	4. ENBINT -- SET THIS 'TRUE' IF YOU NEED INTERRUPTS ENABLED
;	   WHILE RUNNING THIS PROGRAM. SET THIS 'FALSE' IF YOU DO
;	   NOT USE INTERRUPTS.
;
;
;
;
FALSE	EQU	0		;DEFINE FALSE
TRUE	EQU	NOT FALSE	;..TRUE
;
TEST	EQU	FALSE		;NOT TESTING
;
S100	EQU	TRUE		;S-100 CONTROLLER
;
FASTCPU	EQU	TRUE		;RUNNING AT 4 MHZ
;
ENBINT	EQU	FALSE		;WE DON'T USE INTPS





;	---EQUATES---
;
;
STRT	EQU	100H		;PROGRAM START ADDRESS
STACK	EQU	100H		;STACK ADDRESS
LMSK	EQU	0FFH		;LSB MASK
WBOOT	EQU	0		;CPM WARM BOOT
BDOS	EQU	5		;BDOS ENTRY POINT
WORST	EQU	0B6D9H		;WORST CASE DATA PATTERN
DEBUG	EQU	0F000H		;DEBUG ENTRY POINT
;
RPT	EQU	80H		;REPEAT
CTSA	EQU	0C4H		;CLEAN TRACK START ADDRESS
GMSA	EQU	0FAH		;START ADDRESS FOR WRITE G.M.
;
	IF	FASTCPU
DC1	EQU	12		;DELAY COUNT AT 4 MHZ
SKEW	EQU	10		;FORMAT INTERLACE FACTOR
	ELSE
DC1	EQU	5		;DELAY COUNT AT 2 MHZ
SKEW	EQU	16		;FORMAT INTERLACE FACTOR
	ENDIF
;
MAXHD	EQU	2		;NUMBER OF HEADS
MAXCYL	EQU	612		;NUMBER OF CYLINDERS
LZONE	EQU	656		;LANDING ZONE
MAXSEC	EQU	32		;NUMBER OF SECTORS/TRACK
;
;   DRIVE COMMANDS
;
SKCMD	EQU	3		;SEEK COMMAND
SKOUT	EQU	1		;STEP DIRECTION = OUTWARD
SKIN	EQU	2		;..INWARD
NOPC	EQU	40H		;NO PRE-COMPENSATION
LOWRT	EQU	80H		;LOW WRITE CURRENT
;
;   DRIVE STATUS
;
READY	EQU	1		;DRIVE READY
WRTFLT	EQU	2		;WRITE FAULT
TK00	EQU	4		;TRACK ZERO
RAWINDX	EQU	20H		;RAW INDEX
;
;   CONTROLLER COMMANDS
;
BANK0	EQU	0		;BANK 0 SELECT
BANK1	EQU	1		;BANK 1 SELECT
DBENB	EQU	2		;DATA BUFFER ENABLE
CBENB	EQU	4		;COMPARE BUFFER ENABLE
START	EQU	8		;START COMMAND
;
;   CONTROLLER STATUS
;
INDEX	EQU	10H		;DELAYED INDEX
SECTOR	EQU	20H		;SECTOR
;
;   DRIVE/CONTROLLER I/O
;
	IF	S100	; IF S-100 BUS COMPUTER
CBASE	EQU	70H		;BASE ADR OF THE CONTROLLER
DRCSR	EQU	CBASE		;DRIVE COMMAND/STATUS
EXTCMD	EQU	CBASE+1		;EXTENDED COMMNAND REGISTER
LOSC	EQU	CBASE+2		;SEEK COUNT, LSB
HISC	EQU	CBASE+3		;  * MSB
CTCSR	EQU	CBASE+4		;CONTROLLER COMMAND/STATUS
CTBFR	EQU	CBASE+5		;CONTROLLER BUFFER ADDRESS
CTDP	EQU	CBASE+6		;CONTROLLER DATA PORT
	ELSE		; IF RIBBON CABLE INTERFACE
CBASE	EQU	80H		;BASE ADR OF THE CONTROLLER
DRCSR	EQU	CBASE+7		;DRIVE COMMAND/STATUS
EXTCMD	EQU	CBASE+6		;EXTENDED COMMNAND REGISTER
LOSC	EQU	CBASE+5		;SEEK COUNT, LSB
HISC	EQU	CBASE+4		;  * MSB
CTCSR	EQU	CBASE+3		;CONTROLLER COMMAND/STATUS
CTBFR	EQU	CBASE+2		;CONTROLLER BUFFER ADDRESS
CTDP	EQU	CBASE+1		;CONTROLLER DATA PORT
	ENDIF
;
;   ASCII CHARACTERS 
;
CR	EQU	0DH		;CARRIAGE RETURN
LF	EQU	0AH		;LINE FEED
BELL	EQU	7		;DING!
BKSP	EQU	8		;BACKSPACE
ESC	EQU	1BH		;ESCAPE KEY
;
;   CPM FUNCTION CODES
;
F@CI	EQU	1		;CONSOLE INPUT
F@CO	EQU	2		;CONSOLE OUTPUT
F@PRNT	EQU	9		;PRINT MESSAGES
F@RCB	EQU	10		;READ CONSOLE BUFFER
F@REQ	EQU	11		;GET CONSOLE STATUS

	PAGE



;	============
;	** MACROS **
;	============



;	---CALL BDOS---
;
;
CPM	MACRO	FC
	CALL	SYSTEM		;; SYSTEM CALL ROUTINE
	DB	FC		;; CPM FUNCTION CODE
	ENDM




;	---PRINT MESSAGES---
;
;
PRNT	MACRO	MSG
	LXI	D,MSG		;; ADR OF THE MSG
	CPM	F@PRNT		;; PRINT THE MSG
	ENDM

	PAGE

	ORG	STRT	


;	==========================
;	** PROGRAM ENTRY POINT **
;	==========================
;
;
;
BGN:	LXI	SP,STACK	;USE INTERNAL STACK
	CALL	COFF		;STOP ANY PRIOR ACTIVITY
	PRNT	MSG1		;SAY HELLO
	MVI	A,1
	OUT	EXTCMD		;SLCT DRIVE ZERO
	INR	A
	OUT	DRCSR		;ENABLE INDEX/SECTOR TO DATA BOARD
	CALL	BST		;BUILD SECTOR TABLE
;
;   COMMAND LOOP
;
LOOP:	LXI	SP,STACK	;RESET SP
	PRNT	MSG2		;PRINT MENU
	LDA	BGNHED
	CALL	BTH1		;PRINT START HEAD
	MVI	E,'-'
	CPM	F@CO		;PRINT SEPERATOR
	LDA	ENDHED		;END HEAD NUM
	DCR	A		;..ADJUST IT
	CALL	BTH1		;..PRINT IT
	PRNT	MSG2A		; 'CYLS = '
	LHLD	BGNCYL
	CALL	P3D		;PRINT START CYL
	MVI	E,'-'
	CPM	F@CO		;PRINT SEPERATOR
	LHLD	ENDCYL
	DCX	H
	CALL	P3D		;PRINT END CYL ADR
	PRNT	MSG2B		; 'OPTION?'
;
	MVI	A,1
	CALL	RCB		;GET OPER CMD
	CPI	'C'
	JZ	NEWCYL		;JIF ALTER CYL LIMITS
	CPI	'H'
	JZ	NEWHED		;JIF GET NEW HEAD LIMITS
	CPI	'F'
	JZ	FORMAT		;JIF FORMAT A DISK
	CPI	'I'
	JZ	CLRDIR		;INITIALIZE DIRECTORY
	CPI	'X'
	JZ	XIT		;JIF EXIT TO CPM
;
;   INVALID INPUT
;
INV:	PRNT	MSG3		;PRINT 'INVALID INPUT'
	JMP	LOOP		;DO NEXT CMD
;
;   EXIT TO CPM
;
XIT:	CALL	CRLF		;DO CR.LF
	CALL	COFF		;TURN DRIVE/CTLR OFF
 	IF	TEST
	JMP	DEBUG		;IF WE ARE TESTING
 	ELSE
 	JMP	WBOOT		;WARM BOOT CPM
 	ENDIF




;	---GET NEW HEAD LIMITS---
;
;
NEWHED:	PRNT	MSG27		; 'START HEAD? '
	CALL	NHX		;GET HEAD NUM
	JNC	INV		;JIF INVALID HEAD NUM
	STA	TEMP		;SAVE NEW START HEAD
	PRNT	MSG28		; 'END HEAD? '
	CALL	NHX		;GET HEAD NUM
	JNC	INV		;JIF INVALID HEAD NUM
	INR	A		;FOR PROPER TESTING
	MOV	B,A		;B = END HEAD (+1)
	LDA	TEMP		;A = START HEAD
	CMP	B
	JNC	NH1		;JIF SH > EH
	MOV	L,A
	MOV	H,B
	SHLD	BGNHED		;SAVE NEW HEAD LIMITS
	JMP	LOOP		;DO NEXT CMD
; ERROR, START HEAD > END HEAD
NH1:	PRNT	MSG29		;PRINT ERROR MSG
	JMP	LOOP		;DO NEXT CMD
;
;   GET HEAD NUMBER
;
NHX:	MVI	A,2
	CALL	RCB		;INPUT HEAD NUM FROM OPER
	CALL	CONV		;CONVERT INPUT TO BINARY
	MOV	A,L
	CPI	MAXHD		;TEST HEAD NUM
	RET




;	---GET NEW CYLINDER LIMITS---
;
;
NEWCYL:	PRNT	MSG30		; 'START CYL? '
	CALL	NCX		;GET START CYL ADR
	JNC	INV		;JIF INVALID CYL ADR
	SHLD	TEMP		;SAVE CYL ADR
	PRNT	MSG31		; 'END CYL? '
	CALL	NCX		;GET END CYL ADR
	JNC	INV		;JIF INVALID CYL ADR
	INX	H		;FOR PROPER TESTING
	XCHG			;D/E = END CYL ADR
	LHLD	TEMP		;H/L = START CYL ADR
	CALL	TSUB		;TEST (H/L) - (D/E)
	JNC	NC1		;JIF SC > EC
	SHLD	BGNCYL		;SAVE NEW START CYL ADR
	XCHG
	SHLD	ENDCYL		;SAVE NEW END CYL ADR
	JMP	LOOP		;DO NEXT CMD
; ERROR, START CYL > END CYL
NC1:	PRNT	MSG32		;PRINT ERROR MSG
	JMP	LOOP		;DO NEXT CMD
;
;   GET CYLINDER ADDRESS
;
NCX:	MVI	A,4
	CALL	RCB		;GET CYL ADR FROM OPER
	CALL	CONV		;CONVERT INPUT TO BINARY
	LXI	D,MAXCYL
	JMP	TSUB		;TEST CYL ADR, EXIT




;	---INITIALIZE THE DIRECTORY---
;
;
CLRDIR:	PRNT	MSG37		;PRINT OPTION LIST
	MVI	A,1
	CALL	RCB		;GET OPER RESPONSE
	CPI	'M'
	JZ	LOOP		;RETURN TO MAIN MENU
	CPI	'1'
	JZ	ONE		;INIT 1ST DRIVE
	CPI	'2'
	JZ	TWO		;INIT 2ND DRIVE
	CPI	'B'
	JZ	BOTH		;JIF INIT BOTH DRIVES
	PRNT	MSG3		;PRINT ERROR MSG
	JMP	CLRDIR		;RETRY
; INITIALIZE BOTH DRIVES
BOTH:	CALL	CDSET		;DO SETUP
	LXI	H,0
	CALL	CDIR		;INIT 1ST DRIVE
	LXI	H,MAXCYL/2
	CALL	CDIR		;INIT 2ND DRIVE
	JMP	CDEND		;DONE
; INITIALIZE 1ST DRIVE
ONE:	CALL	CDSET		;DO SETUP
	LXI	H,0
	CALL	CDIR		;INIT 1ST DRIVE
	JMP	CDEND		;DONE
; INITIALIZE 2ND DRIVE
TWO:	CALL	CDSET		;DO SETUP
	LXI	H,MAXCYL/2
	CALL	CDIR		;INIT 2ND DRIVE
;
CDEND:	PRNT	MSG7		; 'INIT DONE'
	MVI	A,32
	STA	SECTBL+32	;RESTORE SECTOR 33
	CALL	STZ		;SEEK TO TRACK ZERO
	JMP	LOOP		;DO NEXT CMD
;
;   CLEAR MULTIPLE CYLINDERS
;
CDIR:	SHLD	CYL		;SAVE CYL ADR
	MVI	A,4
	STA	COUNT		;# CYLS TO INIT
	CALL	SEEK		;SEEK TO TARGET CYL
;
CDIR1:	CALL	HDSEL		;HEAD SELECT
	CALL	WAT		;WRITE A TRACK
	LXI	H,HEAD
	INR	M		;INCR HEAD #
	MOV	A,M
	CPI	MAXHD		;MAX HEAD
	JC	CDIR1		;JIF CON'T ON SAME CYL
	MVI	M,0		;RESET HEAD #
	LHLD	CYL	
	INX	H		;INCR CYL ADR
	SHLD	CYL
	CALL	SEEK		;SEEK TO NEXT CYL
	LXI	H,COUNT
	DCR	M		;DECR CYL CNT
	JNZ	CDIR1		;JIF MORE TO DO
	RET
;
;   SETUP
;
CDSET:	CALL	TKZ		;RESTORE
	LXI	H,WRTCODE
	CALL	SQUIRT		;LOAD WRITE M/CODE
	LXI	H,0
	SHLD	HEAD		;INIT HEAD & SECT
	LXI	H,0E5E5H
	CALL	FDB		;FILL DATA BFR = E5'S
	MVI	A,-1
	STA	SECTBL+32	;FOR 32 SECTORS
	JMP	HDSEL		;SLCT 1ST HEAD, EXIT

	PAGE


;	===================
;	** FORMAT A DISK **
;	===================




;	---FORMAT---
;
;
FORMAT:	CALL	CRLF		;DO CR.LF
	LXI	H,RWEC		;START OF ERROR COUNT
	MVI	B,ECSIZ		;NUM BYTES
	XRA	A
FMT0:	MOV	M,A		;CLEAR ERROR COUNTS
	INX	H
	DCR	B
	JNZ	FMT0
;
	CALL	TKZ		;RESTORE
	CALL	SETUP		;SET START CYL/HEAD
	CALL	SEEK		;SEEK TO 1ST CYL
	CALL	NXP		;PRINT START CYL/HEAD
;
FMT1:	MVI	A,10
	STA	FCNT		;SET FMT RETRY COUNT
;
FMT2:	CALL	WGM		;WRITE GRAY MARKS
	CALL	WHDR		;WRITE HDR INFO
	CALL	VHDR		;VERIFY HDR INFO
	JZ	FMT3		;JIF HDRS OK
	LXI	H,FCNT
	DCR	M		;DECR RETRY COUNT
	JNZ	FMT2		;JIF RETRY FMT
;
FMT3:	CALL	WCD		;DO WORST CASE DATA TEST
	CALL	SPARE		;SPARE BAD SECTS (IF NECESSARY)
	CALL	NXTK		;GOTO NEXT TRACK
	JC	FMT1		;JIF CON'T FMT
	CALL	STZ		;MOVE HEADS TO CYL ZERO
;
;   FORMATTING DONE, PRINT SCOREBOARD
;
SCORE:	PRNT	MSG4		; 'FINISHED...'
	LHLD	TOTAL		;TOTAL NUM ERRORS
	MOV	A,H
	ORA	L
	JNZ	SCR1		;JIF HAD FMT ERRORS
	PRNT	MSG5		; '...NO ERRORS'
	JMP	LOOP		;DO NEXT CMD
;
SCR1:	PRNT	MSG8		; '...ERRORS DETECTED'
	LHLD	TOTAL
	CALL	DEC		;PRINT TOTAL ERROR COUNT
	PRNT	MSG9		; 'TOTAL ERRORS'
	LHLD	TOTAL
	LXI	D,128+1
	CALL	OKTST		;TEST ERROR LIMITS
;
	LHLD	SPARED		;NUM SECTORS SPARED
	CALL	DEC		;..PRINT COUNT
	PRNT	MSG10		; 'SECTORS SPARED'
;
	LHLD	MULTI		;NUM OF MULTI-SECTOR ERRORS
	CALL	DEC		;..PRINT COUNT
	PRNT	MSG11		; 'MULTI SECTOR ERRORS'
	LHLD	MULTI
	MOV	A,H
	ORA	L
	JZ	SCR2		;JIF NO ERRORS
	PRNT	MSG19		; 'RUN RECLAIM'
SCR2:	CALL	CRLF
	CALL	CRLF		;DO 2 CR.LF
; PRINT ERROR COUNTS BY HEAD
	LDA	BGNHED		;1ST HEAD
	STA	COUNT		;INIT HEAD #
SCR3:	LDA	COUNT
	LXI	H,EBH		;TBL OF ERRS BY HEAD
	CALL	WINDX		;INDEX INTO TBL
	XCHG			;H/L = ERROR COUNT
	PUSH	H		;..SAVE IT
	CALL	DEC		;PRINT ERROR COUNT
	PRNT	MSG20		; 'ON HEAD'
	LDA	COUNT
	ADI	'0'
	MOV	E,A
	CPM	F@CO		;PRINT HEAD #
	POP	H		;H/L = ERROR COUNT
	LXI	D,16+1
	CALL	OKTST		;TEST ERROR LIMITS
	LXI	H,COUNT
	INR	M		;INCR HEAD #
	MOV	A,M
	LXI	H,ENDHED	;LAST HEAD
	CMP	M
	JC	SCR3		;JIF DO NEXT HEAD
	PRNT	MSG22		; 'STRIKE ANY KEY'
	CPM	F@CI		;GET OPER RESPONSE
	CALL	CRLF		;DO CR.LF
	JMP	LOOP		;DO NEXT CMD




;	---WRITE GRAY MARKS---
;
;   'WGM' CLEANS THE TRACK (WRITES ALL ZEROS) & THEN ATTEMPTS
;   TO WRITE 33 GRAY MARKS. A GRAY MARK IS USED TO DENOTE THE
;   START OF A SECTOR.
;
;
WGM:	MVI	A,10
	STA	GCNT		;SET RETRY COUNT
	LXI	H,CTCODE
	CALL	SQUIRT		;LOAD CLEAN TRACK M/CODE
	LXI	H,GMCODE
	CALL	SQUIRT		;LOAD GRAY MARK M/CODE
	CALL	CDB		;CLEAR DATA BFR
;
	MVI	A,CBENB+BANK1
	OUT	CTCSR		;ENB CMP BFR
	XRA	A
	OUT	CTBFR		;INIT BFR ADR
WGM1:	OUT	CTDP		;PUT INCR CNT INTO CMP BFR
	INR	A
	CPI	16
	JC	WGM1
;
WGM2:	CALL	CLNTK		;CLEAN (CLEAR) A TRACK
	DI			;INHIBIT INTPS
	IN	EXTCMD		;RESET RAW INDEX F/F
;
WGM3:	IN	DRCSR		;DRIVE STATUS
	ANI	RAWINDX
	JZ	WGM3		;WAIT FOR RAW INDEX
	IF	FASTCPU
	MVI	A,2
	DCR	A
	JNZ	$-1		;DELAY ABOUT 7 USEC
	ENDIF
	MVI	A,GMSA
	OUT	CTBFR		;SET BFR ADR
	MVI	A,START+BANK1
	OUT	CTCSR		;START WRITE
;
	IN	EXTCMD		;CLEAR RAW INDEX F/F
WGM4:	IN	DRCSR		;DRIVE STATUS
	ANI	RAWINDX
	JZ	WGM4		;WAIT FOR 2ND RAW INDEX
	MVI	A,DC1
	DCR	A
	JNZ	$-1		;ENSURE WRITE OVERLAP
	OUT	CTCSR		;STOP WRITE
	IF	ENBINT		;IF INTPS ENABLED
	EI
	ENDIF
	IN	DRCSR		;DRIVE STATUS
	ANI	WRTFLT
	JNZ	WGM5		;JIF HAD WRITE FAULT
	CALL	CNTGM		;COUNT GRAY MARKS
	RZ			;RIF OK
	MOV	A,B
	STA	COUNT		;SAVE G.M. COUNT
	JMP	WGM6
;
WGM5:	CALL	CLRDF		;CLEAR DRIVE FAULT
	XRA	A
	STA	COUNT		;CLEAR ERROR COUNT
;
WGM6:	LXI	H,GCNT
	DCR	M		;DECR RETRY COUNT
	JNZ	WGM2		;JIF RETRY WRITE
	PRNT	MSG24		;PRINT ERROR MSG
	LDA	COUNT
	CALL	BTH		;PRINT G.M. COUNT
	CALL	PCA		;PRINT CYL ADR
	CALL	PHN		;PRINT HEAD #
	PRNT	MSG25		; 'UNRECOVERABLE...'
	JMP	LOOP		;ABORT!




;	---WRITE HEADERS---
;
;   'WHDR' WRITES THE HEADER INFORMATION FOR EACH SECTOR.
;   THE HEADER CONTAINS TWO BYTES FOR CYLINDER, ONE BYTE
;   FOR THE HEAD, & ONE BYTE FOR THE SECTOR.
;
;
WHDR:	LXI	H,FMTCODE
	CALL	SQUIRT		;SET FMT M/CODE
;
WHDR1:	LXI	H,SECTBL	;SECTOR TABLE ADR
	SHLD	TBLADR		;  SAVE TBL ADR
	MOV	A,M		;1ST SECTOR ADR
	STA	SECADR		;  SAVE IT
	XRA	A
	DI			;INHIBITS INTPS
	OUT	CTCSR		;CLEAR INDEX F/F
;
WHDR2:	IN	CTCSR		;CTLR STATUS
	ANI	INDEX
	JZ	WHDR2		;WAIT FOR INDEX
;
WHDR3:	LXI	H,FTBL
	CALL	DORW		;FORMAT A SECTOR
	CALL	BTA		;BUMP TABLE ADR
	JNZ	WHDR3		;WRITE NEXT HDR
	IF	ENBINT		;IF INTPS ENABLED
	EI
	ENDIF
	RET




;	---VERIFY HEADERS---
;
;   'VHDR' VERIFYS HEADERS WRITTEN BY 'WHDR'
;
;
VHDR:	LXI	H,VERCODE
	CALL	SQUIRT		;LOAD VERIFY M/CODE
	LXI	H,SECTBL	;SECTOR TABLE ADR
	SHLD	TBLADR		;..SAVE IT
	MOV	A,M
	STA	SECADR		;SET 1ST SECT ADR
	XRA	A
	DI			;INHIBIT INTPS
	OUT	CTCSR		;RESET INDEX F/F
;
VHDR1:	IN	CTCSR		;CTLR STATUS
	ANI	INDEX
	JZ	VHDR1		;WAIT FOR INDEX
;
VHDR2:	LXI	H,VTBL
	CALL	DORW		;VERIFY THE HEADER
	RNZ			;RIF HEADER BAD
	CALL	BTA		;BUMP TABLE ADR
	JNZ	VHDR2		;TEST NEXT HDR
	IF	ENBINT		;IF INTPS ENABLED
	EI
	ENDIF
	RET





;	---WORST CASE DATA TEST---
;
;   'WCD' WRITES A WORST CASE DATA PATTERN ONTO EVERY SECTOR
;   OF A TRACK. EACH SECTOR IS READ TWICE. THE DATA PATTERN IS
;   ROTATED ONE POSITION & THE DATA IS REWRITTEN. THE COMPLETE
;   PROCESS IS REPEATED 16 TIMES. ERRORS ARE ACCUMULATED FOR
;   LATER USE BY THE SECTOR SPARING ROUTINE 'SPARE'.
;
;
WCD:	CALL	CEC		;CLEAR ERROR COUNTS
	LXI	H,WORST
	SHLD	DATA		;INIT WORST CASE DATA PATTERN
	MVI	A,16
	STA	RWCNT		;SET LOOP COUNT
	LXI	H,WRTCODE
	CALL	SQUIRT		;LOAD WRITE M/CODE
	LXI	H,RDCODE
	CALL	SQUIRT		;LOAD READ M/CODE
;
WCD1:	LHLD	DATA		;WORST CASE DATA PATTERN
	CALL	FDB		;FILL DATA BUFFER
	CALL	WAT		;WRITE A TRACK
	CALL	STOP		;STOP FORMATTING ?  (RIF NO)
	CALL	R2T		;READ A TRACK TWICE
	CALL	STOP
; ROTATE DATA PATTERN RIGHT 1 BIT. DECR LOOP COUNT.
	LHLD	DATA		;OLD DATA PATTERN
	MOV	A,H
	ORA	A		;CLEAR CY
	RAR			;ROTATE MSB
	MOV	H,A
	MOV	A,L	
	RAR			;ROTATE MSB
	MOV	L,A
	RAR			;A7 = BIT OFF END
	ANI	80H		;KILL UNWANTED BITS
	ORA	H
	MOV	H,A
	SHLD	DATA		;SAVE NEW DATA PATTERN
	LXI	H,RWCNT
	DCR	M		;DECR LOOP COUNT
	JNZ	WCD1		;JIF TEST SAME TRACK
	RET			;TEST DONE, EXIT




;	---SPARE BAD SECTORS---
;
;
SPARE:	LXI	H,RWEC		;ERROR COUNTS (BY SECTOR)
	LXI	B,(MAXSEC+1) SHL 8	;B = SECT CNT, C = ERROR CNT
;
SPR1:	MOV	A,M		;A = SECT ERROR CNT
	ORA	A
	JZ	SPR2		;JIF THIS SECT OK
	INR	C		;INCR ERROR CNT
	MVI	A,MAXSEC+1
	SUB	B		;CALC SECT ADR
	STA	SECADR		;SAVE ADR OF BAD SECTOR
;
SPR2:	INX	H		;INCR TBL ADR
	DCR	B		;DECR SECT CNT
	JNZ	SPR1
	MOV	A,C		;A = # BAD SECTS
	ORA	A
	RZ			;RIF ALL SECTORS OK
	LXI	H,EBH		;ERROR BY HEAD TABLE
	LDA	HEAD
	CALL	WINDX		;INDEX INTO THE TABLE
	XCHG			;H/L = ERROR COUNT
	MVI	B,0
	DAD	B		;ADD TO ERROR COUNT
	XCHG	
	MOV	M,D		;PUT COUNT BACK INTO TABLE
	DCX	H
	MOV	M,E
	LHLD	TOTAL
	DAD	B		;UPDATE TOTAL ERROR COUNT
	SHLD	TOTAL
	MOV	A,C
	DCR	A
	STA	COUNT		;SAVE ERROR COUNT
	JZ	SPR3		;JIF HAD ONE ERROR
	LHLD	MULTI
	INX	H		;INCR MUTLI SECTOR ERROR CNT
	SHLD	MULTI
;
SPR3:	LDA	RWEC+MAXSEC
	ORA	A
	RNZ			;CAN'T SPARE, 33RD SECTOR BAD
	LHLD	SPARED
	INX	H		;INCR # SECTORS SPARED
	SHLD	SPARED
	LXI	H,FMTCODE
	CALL	SQUIRT		;LOAD FMT M/CODE
; CALC REAL SECTOR ADR
	LXI	H,SECTBL	;TBL OF SECT ADRS
	LDA	SECADR		;A = LOGICAL SECTOR TO BE SPARED
	MVI	B,0		;B = PHYSICAL SECTOR ADR
SPR4:	CMP	M
	JZ	SPR5		;JIF FOUND PHYSICAL SECTOR
	INX	H
	INR	B
	JMP	SPR4
;
SPR5:	LXI	H,ONES
	CALL	FSH		;MARK OFF BAD SECTOR
	LXI	H,CYL
	MVI	B,32
	CALL	FSH		;SPARE THE BAD SECTOR
	CALL	PSA		;PRINT SECT ADR
	PRNT	MSG21		; '...SPARED'
	LDA	COUNT
	ORA	A
	RZ			;RIF HAD ONE BAD SECT
	CALL	NXP		;PRINT CYL/HEAD
	PRNT	MSG36		; '...MULTI SECT ERR'
	RET





;	---WRITE A TRACK---
;
;
WAT:	LXI	H,SECTBL
	CALL	WHT		;WRITE EVEN SECTORS
	LXI	H,SECTBL+1	;  DO ODD
;
;   WRITE HALF A TRACK
;
WHT:	SHLD	TBLADR		;SAVE SECTOR TABLE ADR
	MOV	A,M
	STA	SECADR		;SAVE SECTOR ADR
	INR	A		;TEST FOR EOT FLAG
	RZ			;RIF DONE
;
WHT1:	LXI	H,WTBL
	CALL	DORW		;WRITE A SECTOR
	LXI	H,RWEC
	CNZ	BEC		;CIF INCR ERROR CNT
	LHLD	TBLADR		;SECTOR TABLE ADR
	INX	H
	INX	H		;SKIP A SECTOR
	JMP	WHT		;WRITE NEXT SECTOR





;	---READ A TRACK TWICE---
;
;
R2T:	LXI	H,SECTBL+1
	CALL	RHT		;READ ODD SECTORS
	LXI	H,SECTBL
	CALL	RHT		;READ EVEN SECTORS
	LXI	H,SECTBL
	CALL	RHT		;READ EVEN SECTORS
	LXI	H,SECTBL+1	;..READ ODD
;
;   READ HALF A TRACK
;
RHT:	SHLD	TBLADR		;SAVE SECTOR TABLE ADR
	MOV	A,M
	STA	SECADR		;SAVE SECTOR ADR
	INR	A		;TEST FOR EOT FLAG
	RZ			;RIF DONE
;
RHT1:	LXI	H,RTBL
	CALL	DORW		;READ A SECTOR
	LXI	H,RWEC
	CNZ	BEC		;CIF INCR ERROR CNT
	LHLD	TBLADR		;SECTOR TABLE ADR
	INX	H
	INX	H		;SKIP A SECTOR
	JMP	RHT		;READ NEXT SECTOR



;	---FORMAT SINGLE HEADER---
;
;
FSH:	MVI	A,DBENB
	OUT	CTCSR		;ENB DATA BFR
	MVI	A,0FCH
	OUT	CTBFR		;SET BFR ADR
	MVI	C,4
FSH1:	MOV	A,M		
	OUT	CTDP		;PUT HDR INFO INTO BFR
	INX	H
	DCR	C
	JNZ	FSH1
;
	MOV	A,B		;A = SECT ADR TO FMT
	ORA	A
	JNZ	FSH2		;JIF NOT SECT ZERO
	MVI	B,MAXSEC+1	;..END AROUND ON SECT ZERO
FSH2:	XRA	A
	DI			;INHIBIT INTPS
	OUT	CTCSR		;RESET INDEX F/F
FSH3:	IN	CTCSR		;CTLR STATUS
	ANI	INDEX
	JZ	FSH3		;WAIT FOR INDEX PULSE
; FIND PHYSICAL SECTOR
FSH4:	XRA	A
	OUT	CTCSR		;RESET SECTOR F/F
FSH5:	IN	CTCSR		;CTLR STATUS
	ANI	SECTOR
	JZ	FSH5		;WAIT FOR SECTOR PULSE
	DCR	B
	JNZ	FSH4
; FORMAT THE SECTOR
	LDA	FMTCODE+1
	OUT	CTBFR		;SET BFR ADR
	MVI	A,START+BANK1
	OUT	CTCSR		;FMT HDR
	CALL	WFD		;WAIT FOR FMT DONE
	IF	ENBINT		;IF INTPS ENABLED
	EI
	ENDIF
	RET




;	---BUMP TABLE ADDRESS---
;
;
BTA:	LHLD	TBLADR		;ADR OF SECTOR TBL
	INX	H		;INCR TABLE ADR
	SHLD	TBLADR		;..SAVE NEXT TBL ADR
	MOV	A,M		;A = NEXT LOGICAL SECTOR ADDRESS
	STA	SECADR		;..SAVE IT
	INR	A		;END OF TABLE ? (0=YES)
	RET




;	---ERROR LIMIT TEST---
;
;
OKTST:	CALL	TSUB		;TEST (H/L) - (D/E)
	LXI	D,MSG23		; 'OK'
	JC	OK1		;JIF ERRORS WITHIN LIMITS
	LXI	D,MSG26		; 'BAD'
OK1:	CPM	F@PRNT		;PRINT OK/BAD
	RET

	PAGE


;	============================
;	** DISK RELATED FUNCTIONS **
;	============================




;	---REZERO---
;
;
TKZ:	LXI	H,0
	SHLD	CYL		;INIT TARGET CYL ADR
	SHLD	CCA		;INIT CURR CYL ADR
	IN	DRCSR		;DRIVE STATUS
	ANI	TK00		;TRACK ZERO FLAG
	RNZ			;RIF ALREADY AT TRACK ZERO
;
	LXI	H,511		;# CYLS WE CAN SEEK
	CALL	RTZ		;SEEK OUT
	RNZ			;RIF AT TRACK 0
	LXI	H,LZONE+10-511
	CALL	RTZ		;TRY IT AGAIN
	RNZ			;RIF FOUND TRACK ZERO THIS TIME
; PRINT ERROR MSG
	PRNT	MSG6		; 'RESTORE FAILED'
	CALL	PDS		;PRINT DRIVE STATUS
	CALL	CRLF		;DO CR.LF
	JMP	LOOP		;ABORT
;
;   SEEK OUTWARD
;
RTZ:	CALL	RDY		;DRIVE READY ?  (RIF YES)
	MOV	A,L
	OUT	LOSC		;SET LSB OF SEEK COUNT
	MOV	A,H
	OUT	HISC		;SET MSB
	MVI	A,SKOUT
	OUT	EXTCMD		;SET SEEK DIRC = OUTWARD
	MVI	A,SKCMD
	OUT	DRCSR		;ISSUE SEEK CMD
	CALL	WSC		;WAIT FOR SEEK DONE
	IN	DRCSR		;DRIVE STATUS
	ANI	TK00		;TRACK ZERO INDICATOR
	RET




;	---RETURN TO TRACK ZERO---
;
;
STZ:	LXI	H,0
	SHLD	CYL		;SET TARGET CYL = 0
				;..FALL THRU TO 'SEEK'




;	---SEEK---
;
;
SEEK:	LHLD	CCA		;CURR CYL ADR
	XCHG
	LHLD	CYL		;TARGET CYL
	SHLD	CCA		;UPDATE CURR CYL ADR
	XCHG
	CALL	SUBT		; (H/L) - (D/E)
	RZ			;DON'T SEEK IF SAME CYL
	MVI	B,0		;DIRC = OUT
	RAL
	JNC	SEK1		;JIF SEEK OUTWARD
; SEEK INWARD
	MVI	B,2		;DIRC = INWARD
	MOV	A,L		;MAKE SEEK COUNT POSITIVE
	CMA			  ;
	MOV	L,A		  ;
	MOV	A,H		  ;
	CMA			  ;
	MOV	H,A		  ;
	INX	H		  ;
;
SEK1:	LDA	CHA		;A = CURR HEAD ADR
	ORA	B		;B = DIRC
	STA	SKDIR		;..SAVE RESULTS
	LXI	D,512
	CALL	TSUB
	JC	PSK		;JIF SEEK =< 511 CYLS
	DCX	D		;D/E = 511
	CALL	SUBT		; (H/L) - (D/E)
	SHLD	RSKNT		;SAVE RESIDUAL SEEK CNT
	XCHG			;H/L = 511
	CALL	PSK		;SEEK 511 CYLS
	LHLD	RSKNT		;REST OF SEEK
;
;   PARTIAL SEEK
;
PSK:	CALL	RDY		;DRIVE READY ?  (RIF YES)
	MOV	A,L
	OUT	LOSC		;SET SEEK COUNT, LSB
	MOV	A,H
	OUT	HISC		;   * MSB
	LDA	SKDIR
	OUT	EXTCMD		;SET SEEK DIRECTION
	MVI	A,3
	OUT	DRCSR		;ISSUE SEEK CMD
	JMP	WSC		;WAIT FOR SEEK DONE, EXIT




;	---WAIT FOR SEEK COMPLETE---
;
;
WSC:	LXI	H,0		;DELAY COUNT
	MVI	B,3
;
WSC1:	IN	DRCSR		;DRIVE STATUS
	RAL
	JC	WSC2		;JIF IF SEEK DONE
	DCX	H		;DECR DELAY COUNT
	MOV	A,H
	ORA	L
	JNZ	WSC1		;JIF CON'T WAITING
	DCR	B
	JNZ	WSC1		;CON'T WAITING
	PRNT	MSG34		; 'SEEK FAILED'
	PRNT	MSG25		; 'UNRECOVERABLE ERROR'
	JMP	LOOP		;ABORT, SEEK FAILED TO FINISH
;
WSC2:	RAR
	STA	DSTAT		;SAVE DRIVE STATUS
	RET




;	---EXECUTE READ/WRITE COMMANDS---
;
;
DORW:	CALL	RDY		;DRIVE READY ?  (RIF YES)
	MOV	A,M
	OUT	CTCSR		;ENB CMP BFR
	INX	H
	MOV	A,M
	OUT	CTBFR		;SET CMP BFR ADR
	INX	H
;
	XCHG			;D/E = TBL ADR
	LXI	H,CYL
	MVI	B,4
DO1:	MOV	A,M
	OUT	CTDP		;PUT HDR INFO INTO CMP BFR
	INX	H
	DCR	B
	JNZ	DO1
	XCHG			;H/L = TBL ADR
;
	MOV	A,M		;A = CNTL BANK
	INX	H
	MOV	B,A
	OUT	CTCSR		;SLCT CNTL BANK
	MOV	A,M
	OUT	CTBFR		;SET START ADR
	INX	H
	MOV	A,B
	ORI	START
	OUT	CTCSR		;START R/W CMD
;
DO3:	CALL	WFD		;WAIT FOR READ/WRITE TO FINISH
	STA	CSTAT		;SAVE CTLR STATUS
	ANA	M		;TEST CTLR STATUS (0=OK)
	MOV	B,A
	IN	DRCSR		;DRIVE STATUS
	STA	DSTAT		;  SAVE IT
	ANI	WRTFLT		;WRITE FAULT ?
	CNZ	CLRDF		;CIF CLEAR DRIVE FAULT
	ORA	B		;SET/CLEAR ERROR FLAG (0=OK)
	RET




;	---WAIT FOR DONE---
;
;
WFD:	PUSH	H		;SAVE H/L
	LXI	H,0		;DELAY COUNT
;
WFD1:	IN	CTCSR		;CTLR STATUS
	RRC
	JC	WFD2		;JIF READ/WRITE FINISHED
	DCX	H		;DECR DELAY COUNT
	MOV	A,H
	ORA	L
	JNZ	WFD1		;JIF CON'T WAITING
	OUT	CTCSR		;STOP THE CTLR
	PRNT	MSG35		; 'READ/WRITE FAILED'
	PRNT	MSG25		; 'UNRECOVERABLE ERROR'
	JMP	LOOP		;ABORT, READ/WRITE FAILED TO FINISH
;
WFD2:	POP	H		;RESTORE H/L
	IN	CTCSR		;GET NON-CHANGING STATUS
	MOV	B,A		;..SAVE IT
	XRA	A
	OUT	CTCSR		;STOP CTLR
	MOV	A,B
	RET




;	---GOTO NEXT TRACK---
;
;
NXTK:	LHLD	BGNHED
	XCHG			;D = END HEAD, E = START HEAD
	LXI	H,HEAD
	INR	M		;INCR HEAD NUM
	MOV	A,M
	CMP	D
	JNC	NXT1		;JIF GOTO NEW CYL
	CALL	HDSEL		;SLCT NEW HEAD
	JMP	NXP		;PRINT NEW HEAD NUM, EXIT
;
NXT1:	MOV	M,E		;RESET HEAD NUM
	CALL	HDSEL		;SLCT NEW HEAD
	LHLD	ENDCYL
	XCHG			;D/E = END CYL ADR
	LHLD	CYL		;CURR CYL ADR
	INX	H
	SHLD	CYL		;SAVE NEW CYL ADR
	CALL	TSUB		;TEST (H/L) - (D/E)
	RNC			;RIF TESTING DONE
	CALL	SEEK		;SEEK TO NEXT CYL
;
;   PRINT CURRENT CYLINDER/HEAD
;
NXP:	PRNT	MSG33		; 'CYL='
	LHLD	CYL
	CALL	P3D		;PRINT CYL ADR
	PRNT	MSG16		; 'HD='
	LDA	HEAD
	CALL	BTH1		;PRINT HEAD NUM
	STC			;SET FLAG = CON'T TESTING
	RET




;	---HEAD SELECT---
;
;
HDSEL:	LDA	HEAD
	RLC			;SHIFT FOR H/W
	RLC
	ORI	1		;TO MAINTAIN DRIVE SLCT
	OUT	EXTCMD		;SELECT THE HEAD
	STA	CHA		;..SAVE FOR FUTURE USE
	RET




;	---DRIVE READY TEST---
;
;
RDY:	IN	DRCSR		;DRIVE STATUS
	RRC
	RC			;RIF DRIVE READY
	PRNT	MSG12		;PRINT ERROR MSG
	JMP	LOOP		;DO NEXT CMD




;	---CLEAR DRIVE FAULT---
;
;
CLRDF:	XRA	A
	OUT	EXTCMD		;DISABLE DRIVE 0
	JMP	HDSEL		;RE-SELECT DRIVE & CORRECT HEAD




;	---CYLINDER/HEAD SETUP---
;
;
SETUP:	LHLD	BGNCYL
	SHLD	CYL		;INIT CYL ADR
	LDA	BGNHED		;1ST HEAD TO USE
	STA	HEAD		;..MAKE IT CURRENT
	JMP	HDSEL		;SELECT 1ST HEAD, EXIT




;	---CLEAR DATA BUFFER---
;
;
CDB:	MVI	A,DBENB
	OUT	CTCSR		;ENABLE DATA BFR
	XRA	A
	OUT	CTBFR		;INIT BFR COUNT
	MOV	B,A		;B = COUNT (256)
CDB1:	OUT	CTDP		;WRITE ZEROS INTO DATA BFR
	DCR	B
	JNZ	CDB1
	RET




;	---FILL DATA BUFFER---
;
;
FDB:	MVI	A,DBENB
	OUT	CTCSR		;ENABLE DATA BFR
	XRA	A
	OUT	CTBFR		;INIT BFR ADR
	MVI	B,128
;
FDB1:	MOV	A,H
	OUT	CTDP		;DATA PATTERN, MSB
	MOV	A,L
	OUT	CTDP		;..LSB
	DCR	B
	JNZ	FDB1
	RET




;	---CLEAN A TRACK---
;
;
CLNTK:	MVI	A,CTSA
	OUT	CTBFR		;INIT BFR ADR
	IN	EXTCMD		;RESET RAW INDEX F/F
;
CT1:	IN	DRCSR		;DRIVE STATUS
	ANI	RAWINDX
	JZ	CT1		;WAIT FOR INDEX
	MVI	A,START
	OUT	CTCSR		;START CLEANING A TRACK
;
	IN	EXTCMD		;RESET RAW INDEX F/F (AGAIN)
CT2:	IN	DRCSR		;DRIVE STATUS
	ANI	RAWINDX
	JZ	CT2		;WAIT FOR 2ND INDEX
;
	XRA	A
CT3:	DCR	A
	JNZ	CT3		;DELAY TO ENSURE WRITE OVERLAP
	OUT	CTCSR		;STOP CLEANING
	RET




;	---COUNT GRAY MARKS---
;
;
CNTGM:	XRA	A
	MOV	B,A		;INIT COUNT
	OUT	CTCSR		;CLEAR INDEX F/F
CNT1:	IN	CTCSR		;CTLR STATUS
	ANI	INDEX
	JZ	CNT1		;WAIT FOR INDEX
;
CNT2:	XRA	A
	OUT	CTCSR		;CLEAR INDEX/SECTOR F/F'S
CNT3:	IN	CTCSR
	ANI	SECTOR
	JZ	CNT3		;WAIT FOR SECTOR
	INR	B		;INCR SECTOR COUNT
	IN	CTCSR
	ANI	INDEX
	JZ	CNT2		;JIF CON'T COUNTING
 	MOV	A,B
	SUI	MAXSEC+1	;NUMBER OF SECTORS PER TRACK
	RET			;IF A=0, COUNT IS OK




;	---SQUIRT MICROCODE---
;
;
SQUIRT:	MOV	A,M
	OUT	CTCSR		;SLCT BANK
	INX	H
	MOV	A,M
	OUT	CTBFR		;SET CTLR BFR ADR
	INX	H
;
SQ1:	MOV	A,M
	ORA	A
	RZ			;RIF DONE
	INX	H		;INCR TBL ADR
	MOV	B,A		;B = COUNT
	RAL
	JC	SQ3		;JIF REPEAT
;
SQ2:	MOV	A,M
	OUT	CTDP		;OUTPUT CONTROL INFO
	INX	H
	DCR	B
	JNZ	SQ2
	JMP	SQ1		;DO NEXT STRING
;
SQ3:	ORA	A		;CLEAR CY
	RAR
	MOV	B,A		;B = COUNT
	MOV	A,M
	INX	H
SQ4:	OUT	CTDP		;OUTPUT REPEAT CONTROL INFO
	DCR	B
	JNZ	SQ4
	JMP	SQ1		;DO NEXT STRING




;	---COMMAND TABLES---
;
;
;   FORMAT
;
FTBL:	DB	2		;DATA BFR ENB
	DB	0FCH		;DATA BFR ADR
	DB	BANK1		;CNTL BANK
	DB	0E4H		;START ADR
	DB	0		;STATUS MASK
;
;   VERIFY
;
VTBL:	DB	4		;CMP BFR ENABLE
	DB	13H		;CMP BFR ADR
	DB	BANK0		;CONTROL BANK
	DB	0		;START ADR
	DB	0EH		;STATUS MASK
;
;   WRITE
;
WTBL:	DB	5		;CMP BFR ENB
	DB	0E6H		;CMP BFR ADR
	DB	BANK1		;CNTL BANK
	DB	0D3H		;START ADR
	DB	0EH		;STATUS MASK
;
;   READ
;
RTBL:	DB	4		;CMP BFR ENB
	DB	0EAH		;CMP BFR ADR
	DB	BANK0		;CNTL BANK
	DB	0D7H		;START ADDRESS
	DB	0EH		;STATUS MASK




;	---CLEAR A TRACK MICROCODE---
;
;
CTCODE	EQU	$		;  MINISCRIBE     06-09-81
;
	DB	0		
	DB	GMSA		
	DB	RPT+59,50H	
	DB	1,0D0H		
	DB	RPT+5,55H	
	DB	2,59H		
	DB	50H		
	DB	0		




;	---WRITE GRAY MARK MICROCODE---
;
;
GMCODE	EQU	$		;  MINISCRIBE     06-09-81
;
	DB	1		
	DB	GMSA		
	DB	RPT+5,50H	
	DB	1,0D0H		
	DB	RPT+3,51H	
	DB	RPT+44,50H	
	DB	RPT+4,55H	
	DB	2,59H		
	DB	50H		
	DB	0		




;	---FORMAT MICROCODE---
;
;
FMTCODE	EQU	$		;  MINISCRIBE     06-09-81
;
	DB	1		
	DB	0E4H		
	DB	2,40H		
	DB	41H		
	DB	RPT+3,40H	
	DB	RPT+17,50H	
	DB	2,5BH		
	DB	0DDH		
	DB	RPT+4,0		
	DB	3,5DH		
	DB	50H		
	DB	0FH		
	DB	0		




;	---VERIFY MICROCODE---
;
;
VERCODE	EQU	$		;  MINISCRIBE     06-09-81
;
	DB	0		
	DB	0		
	DB	2,40H		
	DB	41H		
	DB	RPT+3,40	
	DB	RPT+12,6DH	
	DB	1,63H		
	DB	RPT+4,65H	
	DB	RPT+2,67H	
	DB	2,40H		
	DB	0FH		




;	---WRITE MICROCODE---
;
;
WRTCODE	EQU	$		;  MINISCRIBE     06-09-81
;
	DB	1		
	DB	0D3H		
	DB	2,40H		
	DB	41H		
	DB	RPT+3,40H	
	DB	RPT+12,6DH	
	DB	1,63H		
	DB	RPT+4,65H	
	DB	RPT+2,67H	
	DB	2,49H		
	DB	40H		
	DB	RPT+17,50H	
	DB	5,5BH		
	DB	0DDH		
	DB	5DH		
	DB	50H		
	DB	0FH		
	DB	0		




;	---READ MICROCODE---
;
;
RDCODE	EQU	$		;  MINISCRIBE     06-09-81
;
	DB	0		
	DB	0D7H		
	DB	2,40H		
	DB	41H		
	DB	RPT+3,40H	
	DB	RPT+12,6DH	
	DB	1,63H		
	DB	RPT+4,65H	
	DB	RPT+2,67H	
	DB	1,49H		
	DB	RPT+2,40H	
	DB	RPT+12,6DH	
	DB	3,63H		
	DB	0E7H		
	DB	67H		
	DB	RPT+7,0FH	
;
	DB	2,40H		
	DB	41H		
	DB	RPT+3,40H	
	DB	RPT+12,6DH	
	DB	1,63H		
	DB	RPT+2,65H	
	DB	RPT+2,60H	
	DB	RPT+2,67H	
	DB	1,0FH		
	DB	0		

	PAGE


;	======================================
;	** SUBROUTINES, MESSAGES, & STORAGE **
;	======================================




;	---CALL CPM---
;
;   USED TO GO TO CPM (VIA BDOS) TO PERFORM NON-DISK
;   I/O. ALL REGISTERS (EXCEPT 'A') ARE SAVED & THEN
;   RESTORED AFTER THE FUNCTION IS COMPLETE. THE
;   CALLING SEQUENCE IS ---
;
;	CALL	SYSTEM		;ENTRY POINT
;	DB	FC		;FUNCTION CODE
;
;
SYSTEM:	XTHL			;H/L = ADR OF F.C.
	PUSH	D		;SAVE REGS
	PUSH	B
	MOV	C,M		;C = FUNCTION CODE
	INX	H		;H/L = RETURN ADR
	PUSH	H		;  SAVE IT
	CALL	BDOS		;DO CPM FUNCTION
	POP	H		;RESTORE RETURN ADR
	POP	B		;RESTORE REGS
	POP	D
	XTHL			;STACK = RET ADR
	ORA	A		;SET 8080 FLAGS
	RET




;	---READ CONSOLE BUFFER---
;
;   READS A STRING OF ASCII CHARACTERS. LOWER CASE CHARACTERS ARE
;   TRANSLATED TO UPPER CASE. USES THE CPM 'READ BUFFER' FUNCTION.
;
;
;	ENTRY:	A = INPUT CHARACTER COUNT
;
;	EXIT:	A = FIRST CHARACTER IN THE STRING
;	      D/E = BUFFER ADDRESS OF THE FIRST CHARACTER
;
;
;   ERRORS - - IF AN ERROR OCCURES, 'RCB' IS ABORTED & THE
;	       PROGRAM RESUMES RUNNING AT 'LOOP'.
;
;
RCB:	LXI	D,RDBFR		;READ BFR
	INR	A		;FOR N+1 CHARS
	STAX	D		;SET CHAR COUNT
	MOV	B,A		;..SAVE THE COUNT
	CPM	F@RCB		;READ THE STRING
	CALL	CRLF		;DO CR.LF
	LXI	H,RDBFR+1
	MOV	A,M		;A = INPUT CHAR COUNT
	ORA	A
	JZ	INV		;ERROR, NO CHARS INPUT
	CMP	B		;B = MAX CHAR CNT +1
	JNC	INV		;ERROR, TOO MANY INPUT CHARS
; CONVERT L/C TO U/C
	MOV	B,A		;B = # CHARS TO CONVERT
RCB1:	INX	H		;INCR BFR ADR
	MOV	A,M
	CALL	UCT		;CONVERT
	MOV	M,A
	DCR	B
	JNZ	RCB1
	LXI	D,RDBFR+2	;D/E = ADR OF 1ST CHAR IN STRING
	LDAX	D		;..GET IT
	RET




;	---STOP TEST---
;
;   TEST FOR "ESC" KEY. IF FOUND, ABORT FUNCTION.
;
;
STOP:	CPM	F@REQ		;GET CONSOLE STATUS
	RZ			;RIF DATA NOT AVAIL
	CPM	F@CI		;GET INPUT CHAR
	ANI	7FH		;KILL PARITY BIT
	CPI	ESC		;"ESC" KEY ?
	RNZ			;NO, EXIT
	PRNT	MSG18		; 'FUNCTION ABORTED'
	CALL	PCA		;PRINT CYL ADR
	CALL	PHN		;PRINT HEAD #
	CALL	CRLF		;DO CR.LF
	CALL	STZ		;MOVE HEADS BACK TO TRACK 00
	JMP	SCORE		;PRINT SCOREBOARD, ABORT




;	---BUILD SECTOR ADDRESS TABLE---
;
;
BST:	LXI	H,SECTBL	;SECTOR TABLE 
	MVI	B,MAXSEC+3
	MVI	A,-1		;A = SLOT EMPTY FLAG
BST1:	MOV	M,A		;PRE-FILL TABLE
	INX	H
	DCR	B
	JNZ	BST1
;
	LXI	D,0		;INIT TABLE INDEX
	MVI	B,0		;B = REAL SECTOR ADR
BST2:	LXI	H,SECTBL	;BASE ADR OF SECT TBL
	DAD	D		;INDEX INTO TABLE
	MOV	A,M		;A = TABLE ENTRY
	INR	A		;TEST FOR EMPTY SLOT
	JZ	BST3		;JIF STUFF TBL ENTRY
	INR	E		;INCR TBL INDEX
	MOV	A,E
	ANI	1FH		;KILL UNWANTED BITS
	MOV	E,A
	JMP	BST2		;TRY NEXT TABL ENTRY
;
BST3:	MOV	M,B		;PUT SECT ADR INTO TABLE SLOT
	INR	B		;INCR SECTOR ADR
	MOV	A,B
	CPI	MAXSEC		;ARE WE DONE ?
	JNC	BST4
	MVI	A,SKEW
	ADD	E		;ADD SKEW FACTOR TO TBL INDEX
	ANI	1FH		;KILL UNWANTED BITS
	MOV	E,A
	JMP	BST2		;DO NEXT TBL ENTRY
;
BST4:	MVI	A,32
	STA	SECTBL+MAXSEC	;SET 33RD SECTOR
	RET




;	---TURN DRIVE/CONTROLLER OFF---
;
;
COFF:	XRA	A
	OUT	CTCSR		;STOP CTLR
	OUT	DRCSR		;TURN OFF INTERFACE
	OUT	EXTCMD		;DE-SELECT THE DRIVE
	RET




;	---CONVERT---
;
;   CONVERTS AN ASCII CHARACTER STRING TO BINARY.
;
;   EXIT:	H/L = BINARY DATA
;
;
;   ERROR:	IF A CONVERSION ERROR IS DETECTED 'CONV' IS
;		ABORTED & THE PROGRAM RESUMES RUNNING AT
;		'LOOP'.
;
;
;
CONV:	LXI	H,RDBFR+1	;READ BFR
	MOV	B,M		;B = INPUT CHAR COUNT
	INX	H
	XCHG
	LXI	H,0
;
CNV1:	LDAX	D		;GET ASCII CHAR
	INX	D		;POINT TO NEXT CHAR IN STRING
	CALL	HTB		;CONVERT TO BINART
	JC	INV		;JIF FOUND NON-HEX CHAR
	DAD	H		;SHIFT H/L LEFT 4   (1 DIGIT)
	DAD	H
	DAD	H
	DAD	H
	ORA	L		; 'OR' IN NEW DIGIT
	MOV	L,A
	DCR	B		;DECR COUNT
	JNZ	CNV1		;JIF NOT DONE
	RET




;	---HEX/BINARY CONVERSION---
;
;   CONVERTS AN ASCII CHARACTER (IN 'A') TO A BINARY DIGIT
;   (RETURNED IN 'A'). THE CARRY IS SET (CY=1) IF A NON-HEX 
;   CHARACTER IS ENCOUNTERED.
;
;
HTB:	ANI	7FH		;KILL PARITY BIT
	SUI	'0'
	RC			;ERROR, CHAR < 0
	CPI	9+1
	CMC
	RNC			;RIF CHAR 0-9
	SUI	7		;MAKES CHARS A-F
	CPI	0AH
	RC			;RIF INVALID CHAR
	CPI	10H		;CHAR > 'F' ?
	CMC
	RET




;	--PRINT 3 DIGITS---
;
;
P3D:	MOV	A,H
	CALL	BTH1		;PRINT MSD
	MOV	A,L
; FALL THRU TO 'BTH' TO PRINT LS BYTE




;	---BINARY/HEX CONVERSION---
;
;   CONVERTS BINARY DATA (IN 'A') TO 2 ASCII
;   HEX CHARACTERS & PRINTS THOSE CHARACTERS.
;
;
BTH:	PUSH	D		;SAVE D/E
	PUSH	PSW
	RRC			;MOVE MSD TO LSD
	RRC
	RRC
	RRC
	CALL	BTH1		;CONVERT MSD & PRINT IT
	POP	PSW
	CALL	BTH1		;  * LSD
	POP	D		;RESTORE D/E
	RET
;
BTH1:	ANI	0FH		;KILL MSD
	ADI	'0'
	CPI	'9'+1
	JC	BTH2		;JIF CHAR 0-9
	ADI	7		;CHAR A-F
BTH2:	MOV	E,A
	CPM	F@CO		;PRINT THE DIGIT
	RET




;	---UPPER CASE TRANSLATION---
;
;   CONVERTS LOWER CASE CHARACTERS TO UPPER CASE.
;
;
UCT:	ANI	7FH		;KILL PARITY BIT
	CPI	61H
	RC			;RIF NOT L/C CHAR
	CPI	7BH	
	RNC			;RIF NOT L/C CHAR
	SUI	20H		;DO CONVERSION
	RET




;	---PRINT DECIMAL---
;
;   PRINT THE CONTENTS OF 'H/L' IN DECIMAL. LEADING
;   ZEROS ARE CONVERTED TO SPACES.
;
;
DEC:	PUSH	H		;SAVE COUNT
	CALL	CRLF		;DO CR.LF
	POP	H
	MOV	A,L
	ORA	H
	JNZ	DEC2		;JIF VALUE <> 0
	MVI	E,' '
	MVI	B,4
DEC1:	CPM	F@CO		;PRINT 4 SPACES
	DCR	B
	JNZ	DEC1
	MVI	E,'0'
	CPM	F@CO		;PRINT 1 ZERO
	RET
;
DEC2:	MVI	B,0		;RESET NON-ZERO FLAG
	LXI	D,10000
	CALL	DX		;PRINT 10K'S
	LXI	D,1000
	CALL	DX		;PRINT 1K'S
	LXI	D,100
	CALL	DX		;PRINT 100'S
	LXI	D,10
	CALL	DX		;PRINT 10'S
	MOV	A,L
	ADI	'0'		;MAKE NUM ASCII
	MOV	E,A
	JMP	DX4		;PRINT 1'S, THEN EXIT
;
;
;
DX:	MVI	C,0		;NUMBER OF "N"
;
DX1:	MOV	A,L		; (H/L) = (H/L)-(D/E)
	SUB	E
	MOV	L,A
	MOV	A,H
	SBB	D
	MOV	H,A
	JC	DX2
	INR	C		;INCR NUM OF "N"
	JMP	DX1
;
DX2:	DAD	D		;RESTORE #
	MOV	A,C
	ADI	'0'		;CONVERT NUM TO ASCII
	MOV	E,A
	CPI	'0'
	JZ	DX3		;JIF NUM WAS ZERO
	INR	B		;SET FLAG = PRINT ZEROS
	JMP	DX4
;
DX3:	MOV	A,B
	ORA	A
	JNZ	DX4		;JIF PRINT ZEROS
	MVI	E,' '		;LEADING ZEROS ARE SPACES
;
DX4:	CPM	F@CO		;PRINT THE NUM
	RET




;	---CLEAR ERROR COUNTS---
;
;
CEC:	LXI	H,RWEC		;READ/WRITE ERRO COUNTS
	MVI	B,MAXSEC+1	;SIZE OF TABLE
	XRA	A
CEC1:	MOV	M,A
	INX	H
	DCR	B
	JNZ	CEC1
	RET




;	---BUMP ERROR COUNT---
;
;
BEC:	LDA	SECADR		;FAILING SECTOR
	CALL	BINDX		;INDEX INTO READ/WRITE TABLE
	INR	M		;INCR COUNT
	RET




;	---16 BIT SUBTRACTION---
;
;
SUBT:	MOV	A,L		; (H/L) - (D/E)
	SUB	E
	MOV	L,A
	MOV	A,H
	SBB	D
	MOV	H,A
	ORA	L		;TEST RESULTS FOR ZERO
	RET




;	---16 BIT SUBTRACTION TEST ---
;
;
TSUB:	MOV	A,L		; (H/L) - (D/E)
	SUB	E
	MOV	A,H
	SBB	D
	RET




;	---BYTE WIDE INDEX---
;
;
BINDX:	PUSH	D
	MOV	E,A
	MVI	D,0
	DAD	D
	POP	D
	RET




;	---WORD WIDE INDEX---
;
;
WINDX:	ADD	A		;FOR WORD-WIDE INDEXING
	MOV	E,A
	MVI	D,0
	DAD	D		;INDEX INTO THE TABLE
	MOV	E,M
	INX	H
	MOV	D,M		;D/E = TABLE ENTRY
	RET			;H/L = ENTRY ADR +1





;	---PRINT DRIVE STATUS---
;
;
PDS:	PRNT	MSG13		; 'DST='
	LDA	DSTAT
	JMP	BTH		;PRINT STATUS, EXIT




;	---PRINT CONTROLLER STATUS---
;
;
PCS:	PRNT	MSG14		; 'CST='
	LDA	CSTAT
	JMP	BTH		;PRINT STATUS, EXIT




;	---PRINT CYLINDER ADDRESS---
;
;
PCA:	PRNT	MSG15		; 'CYL='
	LHLD	CYL
	JMP	P3D		;PRINT CYL ADR, EXIT




;	---PRINT HEAD NUMBER---
;
;
PHN:	PRNT	MSG16		; 'HD='
	LDA	HEAD
	JMP	BTH1		;PRINT HEAD #, EXIT




;	---PRINT SECTOR ADDRESS---
;
;
PSA:	PRNT	MSG17		; 'SECT='
	LDA	SECADR
	JMP	BTH		;PRINT ADR, EXIT




;	---CARRIAGE RETURN, LINE FEED---
;
;
CRLF:	PUSH	D		;SAVE D/E
	MVI	E,CR
	CPM	F@CO
	MVI	E,LF
	CPM	F@CO
	POP	D		;RESTORE D/E
	RET




;	---MESSAGES---
;
;
MSG1:	DB	CR,LF,LF,LF
	DB	'MHFMT -- Vers 1.0',CR,LF
	DB	'12-Apr-83',CR,LF,'$'
;
MSG2:	DB	CR,LF,LF,LF
	DB	'Select one of the following Options ---'
	DB	CR,LF,LF
	DB	'  C = Alter Cylinder Limits',CR,LF
	DB	'  F = Format',CR,LF
	DB	'  H = Alter Head Limits',CR,LF
	DB	'  I = Initialize the Directory',CR,LF
	DB	'  X = Exit to CPM',CR,LF,LF
	DB	'Heads =   $'
MSG2A:	DB	CR,LF,' Cyls = $'
MSG2B:	DB	CR,LF,LF,'Option? $'
;
MSG3:	DB	BELL,CR,LF
	DB	'* Invalid Input'
	DB	CR,LF,'$'
;
MSG4:	DB	CR,LF,LF,LF
	DB	'Formatting Finished - $'
;
MSG5:	DB	'No Errors Detected',CR,LF,'$'
;
MSG6:	DB	BELL,CR,LF,LF,'* Restore Failed  $'
;
MSG7:	DB	CR,LF,LF,'* Directory Initialized',CR,LF,'$'
;
MSG8:	DB	'Errors were Detected',CR,LF,LF,'$'
;
MSG9:	DB	' Total Errors $'
;
MSG10:	DB	' Sectors Spared$'
;
MSG11:	DB	' Multiple Sector Errors $'
;
MSG12:	DB	BELL,CR,LF,LF,'* Drive not Ready',CR,LF,'$'
;
MSG13:	DB	'DST=$'
;
MSG14:	DB	'  CST=$'
;
MSG15:	DB	'  Cyl=$'
;
MSG16:	DB	'  Hd=$'
;
MSG17:	DB	'  Sect=$'
;
MSG18:	DB	BELL,CR,LF,LF,'* Format Aborted! $'
;
MSG19:	DB	' (Run RECLAIM/BADLIM)$'
;
MSG20:	DB	' Errors on Head $'
;
MSG21:	DB	'  Spared',CR,LF,'$'
;
MSG22:	DB	CR,LF,LF,'Strike any key to continue...$'
;
MSG23:	DB	' (Within Acceptable Limits)$'
;
MSG24:	DB	BELL,CR,LF,LF,'* Can''t Write Gray Marks  CNT=$'
;
MSG25:	DB	CR,LF,'  (This is an UNRECOVERABLE Error !!!!!)',CR,LF,'$'
;
MSG26:	DB	' (Exceeds Acceptable Limits)$'
;
MSG27:	DB	CR,LF,'Starting Head? $'
;
MSG28:	DB	CR,LF,'Ending Head? $'
;
MSG29:	DB	CR,LF,LF,BELL
	DB	'* Error -- Starting Head > Ending Head'
	DB	CR,LF,'$'
;
MSG30:	DB	CR,LF,'Starting Cylinder? $'
;
MSG31:	DB	CR,LF,'Ending Cylinder? $'
;
MSG32:	DB	CR,LF,LF,BELL
	DB	'* Error -- Starting Cylinder > Ending Cylinder'
	DB	CR,LF,'$'
;
MSG33:	DB	CR,'Cyl=$'
;
MSG34:	DB	BELL,CR,LF,LF
	DB	'* Seek Failed to Finish (Time-Out Error)'
	DB	CR,LF,'$'
;
MSG35:	DB	BELL,CR,LF,LF
	DB	'* Read/Write Failed to Finish (Time-Out Error)'
	DB	CR,LF,'$'
;
MSG36:	DB	'  Multiple Sector Error',CR,LF,'$'
;
MSG37:	DB	CR,LF,LF,LF
	DB	'Select one of the following options ---'
	DB	CR,LF,LF
	DB	'   1 = Initialize 1st Drive',CR,LF
	DB	'   2 = Initialize 2nd Drive',CR,LF
	DB	'   B = Initialize Both Drives',CR,LF
	DB	'   M = Return to Main Menu',CR,LF,LF
	DB	'Option? $'




;	---STORAGE---
;
;
CYL:	DS	2		;CYLINDER ADDRESS
HEAD:	DS	1		;HEAD NUMBER
SECADR:	DS	1		;SECTOR ADDRESS
CSTAT:	DS	1		;CONTROLLER STATUS
DSTAT:	DS	1		;DRIVE STATUS
CHA:	DS	1		;COMPOSITE HEAD ADDRESS
CCA:	DS	2		;CURRENT CYLINDER ADDRESS
COUNT:	DS	1		;G.M. COUNT
FCNT:	DS	1		;FORMAT RETRY COUNT
GCNT:	DS	1		;G.M. RETRY COUNT
RWCNT:	DS	1		;'WCD' LOOP COUNT
ONES:	DB	-1,-1,-1,-1	;BAD SECTOR MARK OFF
TBLADR:	DS	2		;SECTOR TABLE ADDRESS
SECTBL:	DS	MAXSEC+3	;SECTOR ADDRESS TABLE
DATA:	DS	2		;WORST CASE DATA PATTERN
RSKNT:	DS	2		;RESIDUAL SEEK COUNT
SKDIR:	DS	1		;SEEK DIRECTION
;
;   ERROR COUNTS
;
RWEC:	DS	MAXSEC+1	;ERROR COUNTS BY SECTOR
EBH:	DS	MAXHD*2		;ERROR COUNTS BY HEAD
TOTAL:	DS	2		;TOTAL ERRORS DURING FORMATTING
SPARED:	DS	2		;NUMBER OF SPARED SECTORS
MULTI:	DS	2		;NUMBER OF MULTI SECTOR ERRORS
ECSIZ	EQU	$-RWEC		;SIZE OF ERROR COUNTS
;
;   HEAD/CYLINDER LIMITS
;
BGNHED:	DB	0		;STARTING HEAD
ENDHED:	DB	MAXHD		;ENDING HEAD
BGNCYL:	DW	0		;STARTING CYLINDER
ENDCYL:	DW	MAXCYL		;ENDING CYLINDER
TEMP:	DS	2		;TEMP STORAGE FOR NEW LIMITS
;
RDBFR:	DS	10		;CONSOLE READ BUFFER


LAST	EQU	$		;DEFINES END OF PROGRAM



	END
