	TITLE	'MHMDC -- MINISCRIBE MS-3012 MOVE DRIVER CODE'

;	04-18-83



;   MHMDC is used to move the backend driver MSBED to its TARGET
;   location. Read the file "BED.DOC" for information regarding
;   usage of this program.





;	---PROGRAM CONFIGURATION---
;
;
;   THESE STATEMENTS ARE USED TO CONFIGURE THE PROGRAM.
;
;	1. TEST -- SET THIS 'FALSE' BEFORE USING THE PROGRAM. 
;
;	2. S100 -- SET THIS 'TRUE' IF YOU ARE USING A CONTROLLER WITH
;	   AN S-100 BUS INTERFACE (STS). SET THIS 'FALSE' IF YOU ARE
;	   USING A CONTROLLER WITH THE RIBBON CABLE INTERFACE (STR).
;
;	3. MAXFD -- SET THIS TO THE NUMBER OF FLOPPY DISK DRIVES
;	   ATTACHED TO YOUR SYSTEM.
;
;
FALSE	EQU	0
TRUE	EQU	NOT FALSE
;
TEST	EQU	FALSE		;NOT TESTING
;
S100	EQU	TRUE		;S-100 CONTROLLER
;
MAXFD	EQU	2		;NUMBER OF FLOPPY DRIVES





;	---EQUATES---
;
;
TADR	EQU	62*1024		;TARGET ADDRESS
DADR	EQU	400H		;DRIVER CODE ADDRESS
HELLO	EQU	DADR+1EH	;SIGNON MESSAGE
DSIZE	EQU	2048		;DRIVER CODE SIZE
;
STRT	EQU	100H		;PROGRAM START ADDRESS
STACK	EQU	100H		;STACK ADDRESS
WBOOT	EQU	0		;CPM WARM BOOT
CDISK	EQU	4		;CURRENT DISK/USER
BDOS	EQU	5		;BDOS ENTRY POINT
DEBUG	EQU	0F000H		;DEBUG ENTRY POINT
RPT	EQU	80H		;REPEAT
;
;   CONTROLLER COMMANDS
;
BANK0	EQU	0		;BANK 0 SELECT
BANK1	EQU	1		;BANK 1 SELECT
DBENB	EQU	2		;DATA BUFFER ENABLE
CBENB	EQU	4		;COMPARE BUFFER ENABLE
START	EQU	8		;START COMMAND
;
;   DRIVE/CONTROLLER I/O
;
	IF	S100	; IF S-100 BUS COMPUTER
CBASE	EQU	70H		;BASE ADR OF THE CONTROLLER
DRCSR	EQU	CBASE		;DRIVE COMMAND/STATUS
EXTCMD	EQU	CBASE+1		;EXTENDED COMMNAND REGISTER
LOSC	EQU	CBASE+2		;SEEK COUNT, LSB
HISC	EQU	CBASE+3		;  * MSB
CTCSR	EQU	CBASE+4		;CONTROLLER COMMAND/STATUS
CTBFR	EQU	CBASE+5		;CONTROLLER BUFFER ADDRESS
CTDP	EQU	CBASE+6		;CONTROLLER DATA PORT
	ELSE		; IF RIBBON CABLE INTERFACE
CBASE	EQU	80H		;BASE ADR OF THE CONTROLLER
DRCSR	EQU	CBASE+7		;DRIVE COMMAND/STATUS
EXTCMD	EQU	CBASE+6		;EXTENDED COMMNAND REGISTER
LOSC	EQU	CBASE+5		;SEEK COUNT, LSB
HISC	EQU	CBASE+4		;  * MSB
CTCSR	EQU	CBASE+3		;CONTROLLER COMMAND/STATUS
CTBFR	EQU	CBASE+2		;CONTROLLER BUFFER ADDRESS
CTDP	EQU	CBASE+1		;CONTROLLER DATA PORT
	ENDIF
;
;   ASCII CHARACTERS 
;
CR	EQU	0DH		;CARRIAGE RETURN
LF	EQU	0AH		;LINE FEED
BELL	EQU	7		;DING!
ESC	EQU	1BH		;ESCAPE KEY
;
;   CPM FUNCTION CODES
;
F@CO	EQU	2		;CONSOLE OUTPUT
F@PRNT	EQU	9		;PRINT MESSAGES




;	---PRINT MACRO---
;
;
PRINT	MACRO	MSG
	LXI	D,MSG		;; ADR OF PRINT MSG
	MVI	C,F@PRNT	;; CPM FUNCTION CODE
	CALL	BDOS		;; GO PRINT MSG
	ENDM

	PAGE

	ORG	STRT


;	---PROGRAM ENTRY POINT---
;
;
MDC:	LXI	SP,$		;SET SP
	PRINT	HELLO		;PRINT SIGNON MSG
	XRA	A
	OUT	CTCSR
	OUT	EXTCMD
	OUT	DRCSR		;STOP ANY PRIOR ACTIVITY
	LDA	CDISK
	STA	SCD		;SAVE CURR LOGGED DISK/USER
	LXI	H,RDCODE
	CALL	SQUIRT		;LOAD READ MICROCODE
	LXI	H,WRTCODE
	CALL	SQUIRT		;LOAD WRITE MICROCODE
;
;   DRIVER ALREADY INSTALLED ?
;
	LHLD	1		;WARM BOOT LINK ADDRESS
	LXI	D,7*3
	DAD	D		;H/L = ADR OF DISK RTNS
	LXI	D,DADR+3	;ADR OF DRIVE CODE
	LXI	B,4*3
MDC1:	LDAX	D
	CMP	M
	JNZ	MDC2		;JIF DRIVER NOT INSTALLED
	INX	H
	INX	D
	DCX	B
	MOV	A,B
	ORA	C
	JNZ	MDC1
; ABORT LOAD, DRIVER ALREADY INSTALLED
	MVI	A,1
	OUT	EXTCMD		;RESELECT THE DRIVE
	INR	A
	OUT	DRCSR		;ENABLE THE INTERFACE
	PRINT	MSG1		; 'LOAD ABORTED...'
	JMP	0		;WARM BOOT SYSTEM
;
;   MOVE DRIVER CODE
;
MDC2:	LXI	H,DADR		;ADR OF DRIVER CODE
	LXI	D,TADR		;TARGET ADR
	LXI	B,DSIZE		;SIZE OF DRIVER CODE
;
MDC3:	MOV	A,M		;GET CODE
	STAX	D		;PUT CODE
	INX	H
	INX	D
	DCX	B
	MOV	A,B
	ORA	C
	JNZ	MDC3
;
	PRINT	MSG2		; 'DRIVER LOADED'
	MVI	E,MAXFD+'A'
	MVI	C,F@CO
	CALL	BDOS		;PRINT DRIVE #
	PRINT	MSG3		;CR.LF
	LDA	SCD
	STA	CDISK		;RESTORE ORIGINALLY SELECTED DRIVE
	MVI	A,1
	OUT	EXTCMD		;SLCT H/D DRIVE
	INR	A
	OUT	DRCSR		;ENABLE INTERFACE (CLOCK, SECT, INDX, ECT.)
	MVI	A,MAXFD		;1ST AVAIL DRIVE #
	IF	TEST
	JMP	DEBUG		;GO TO DEBUG IF TESTING
	ELSE
	JMP	TADR		;INIT HARD DISK DRIVER
	ENDIF

	PAGE


;	======================================
;	** SUBROUTINES, MESSAGES, & STORAGE **
;	======================================




;	---SQUIRT MICROCODE---
;
;
SQUIRT:	MOV	A,M
	OUT	CTCSR		;SLCT BANK
	INX	H
	MOV	A,M
	OUT	CTBFR		;SET CTLR BFR ADR
	INX	H
;
SQ1:	MOV	A,M
	ORA	A
	RZ			;RIF DONE
	INX	H		;INCR TBL ADR
	MOV	B,A		;B = COUNT
	RAL
	JC	SQ3		;JIF REPEAT
;
SQ2:	MOV	A,M
	OUT	CTDP		;OUTPUT CONTROL INFO
	INX	H
	DCR	B
	JNZ	SQ2
	JMP	SQ1		;DO NEXT STRING
;
SQ3:	ORA	A		;CLEAR CY
	RAR
	MOV	B,A		;B = COUNT
	MOV	A,M
	INX	H
SQ4:	OUT	CTDP		;OUTPUT REPEAT CONTROL INFO
	DCR	B
	JNZ	SQ4
	JMP	SQ1		;DO NEXT STRING




;	---WRITE MICROCODE---
;
;
WRTCODE	EQU	$		;  MINISCRIBE	06-09-81
;
	DB	1		
	DB	0D3H		
	DB	2,40H		
	DB	41H		
	DB	RPT+3,40H	
	DB	RPT+12,6DH	
	DB	1,63H		
	DB	RPT+4,65H	
	DB	RPT+2,67H	
	DB	2,49H		
	DB	40H		
	DB	RPT+17,50H	
	DB	5,5BH		
	DB	0DDH		
	DB	5DH		
	DB	50H		
	DB	0FH		
	DB	0		




;	---READ MICROCODE---
;
;
RDCODE	EQU	$		;  MINISCRIBE	06-09-81
;
	DB	0		
	DB	0D7H		
	DB	2,40H		
	DB	41H		
	DB	RPT+3,40H	
	DB	RPT+12,6DH	
	DB	1,63H		
	DB	RPT+4,65H	
	DB	RPT+2,67H	
	DB	1,49H		
	DB	RPT+2,40H	
	DB	RPT+12,6DH	
	DB	3,63H		
	DB	0E7H		
	DB	67H		
	DB	RPT+7,0FH	
;
	DB	2,40H		
	DB	41H		
	DB	RPT+3,40H	
	DB	RPT+12,6DH	
	DB	1,63H		
	DB	RPT+2,65H	
	DB	RPT+2,60H	
	DB	RPT+2,67H	
	DB	1,0FH		
	DB	0		




;	---MESSAGES---
;
;
MSG1:	DB	BELL,CR,LF,LF
	DB	'* Load Aborted -- Driver Already Installed'
	DB	CR,LF,LF,'$'
;
MSG2:	DB	CR,LF,LF
	DB	'* Hard Disk Driver Loaded...',CR,LF
	DB	'  Drive Addresses Start at $'
;
MSG3:	DB	':',CR,LF,LF,'$'




;	---STORAGE---
;
;
SCD:	DS	1		;CURRENT DRIVE/USER
FAD:	DS	1		;FIRST AVAILBLE DRIVE




	END
