	TITLE	'MHPUT -- PUT CPM ONTO A MINSCRIBE MS-3012'

;	04-16-83



;   MHPUT is used to write a CPM System (BOOT, BDOS, & CBIOS)
;   onto a MiniScribe MS-3012 hard disk drive. This program
;   uses an XCOMP STS/STR hard disk controller.
;
;	** NOTE --  The data to be written onto the disk MUST
;		    start at 880H in memory.




;	---PROGRAM CONFIGURATION---
;
;   THE FOLLOWING STATEMENTS ARE USED TO CONFIGURE THIS PROGRAM
;   FOR YOUR PARTICULAR HARWARE ENVIRONMENT.
;
;	1. TEST -- SET THIS "FALSE" BEFORE USING THE PROGRAM.
;
;	2. S100 -- SET THIS "TRUE" IF YOU ARE USING A CONTROLLER
;	   WITH AN S-100 BUS INTERFACE (STS). SET THIS "FALSE"
;	   IF YOU ARE USING A CONTROLLER WITH A RIBBON CABLE
;	   INTERTFACE (STR).
;
;
;
FALSE	EQU	0		;DEFINE FALSE
TRUE	EQU	NOT FALSE	;DEFINE TRUE
;
TEST	EQU	FALSE		;NOT TESTING
;
S100	EQU	TRUE		;S-100 CONTROLLER






;	---EQUATES---
;
;
STRT	EQU	100H		;PROGRAM START ADDRESS
STACK	EQU	100H		;STACK ADDRESS
LMSK	EQU	0FFH		;LSB MASK
WBOOT	EQU	0		;WARM BOOT ADDRESS
BDOS	EQU	5		;BDOS LINK ADDRESS
LDADR	EQU	880H		;LOAD ADR OF WRITE DATA
NSECT	EQU	32		;NUMBER SECTORS TO WRITE
MAXSEC	EQU	32		;NUMBER SECTORS PER TRACK
LZONE	EQU	656		;LANDING ZONE
;
ROM	EQU	0F000H		;BASE ADR OF DEBUG
DEBUG	EQU	ROM		;DEBUG ENTRY POINT
TRAP	EQU	ROM+1EH		;DEBUG TRAP ADDRESS
;
RPT	EQU	80H		;REPEAT
INDEX	EQU	10H		;INDEX BIT
;
;   ASCII CHARACTERS
;
CR	EQU	0DH		;CARRIAGE RETURN
LF	EQU	0AH		;LINE FEED
BELL	EQU	7		;DING!
;
;   DRIVE COMMANDS
;
SKCMD	EQU	3		;SEEK
SKOUT	EQU	1		;SEEK DIRECTION = OUTWARD
NOPC	EQU	40H		;NO PRE-COMPENSATION
LOWRT	EQU	80H		;LOW WRITE CURRENT
;
;   DRIVE STATUS
;
READY	EQU	1		;DRIVE READY
WRTFLT	EQU	2		;WRITE FAULT
TK00	EQU	4		;TRACK ZERO
RAWINDX	EQU	20H		;RAW INDEX
;
;   CONTROLLER COMMANDS
;
BANK0	EQU	0		;BANK 0 SELECT
BANK1	EQU	1		;BANK 1 SELECT
DBENB	EQU	2		;DATA BUFFER ENABLE
CBENB	EQU	4		;COMPARE BUFFER ENABLE
START	EQU	8		;START COMMAND
;
;   DRIVE/CONTROLLER I/O
;
	IF	S100	;IF S-100 BUS
CBASE	EQU	70H		;BASE ADR OF THE CONTROLLER
DRCSR	EQU	CBASE		;DRIVE COMMAND/STATUS
EXTCMD	EQU	CBASE+1		;EXTENDED COMMNAND REGISTER
LOSC	EQU	CBASE+2		;SEEK COUNT, LSB
HISC	EQU	CBASE+3		;  * MSB
CTCSR	EQU	CBASE+4		;CONTROLLER COMMAND/STATUS
CTBFR	EQU	CBASE+5		;CONTROLLER BUFFER ADDRESS
CTDP	EQU	CBASE+6		;CONTROLLER DATA PORT
	ELSE		;IF RIBBON CABLE INTERFACE
CBASE	EQU	80H		;BASE ADR OF THE CONTROLLER
DRCSR	EQU	CBASE+7		;DRIVE COMMAND/STATUS
EXTCMD	EQU	CBASE+6		;EXTENDED COMMNAND REGISTER
LOSC	EQU	CBASE+5		;SEEK COUNT, LSB
HISC	EQU	CBASE+4		;  * MSB
CTCSR	EQU	CBASE+3		;CONTROLLER COMMAND/STATUS
CTBFR	EQU	CBASE+2		;CONTROLLER BUFFER ADDRESS
CTDP	EQU	CBASE+1		;CONTROLLER DATA PORT
	ENDIF
;
;   CPM FUNCTION CODES
;
F@CI	EQU	1		;CONSOLE INPUT
F@CO	EQU	2		;CONSOLE OUTPUT
F@PRT	EQU	9		;PRINT MESSAGES




;	---MACRO TO CALL CPM---
;
;
CPM	MACRO	FC
	MVI	C,FC		;; C = FUNCTION CODE
	CALL	BDOS		;; GOTO BDOS
	ENDM




;	---PRINT MACRO---
;
;
PRNT	MACRO	MSG
	LXI	D,MSG		;; D/E = MSG ADR
	CPM	F@PRT		;; PRINT THE MSG
	ENDM

	PAGE

	ORG	STRT



;	---PROGRAM ENTRY POINT---
;
;
PUT:	LXI	SP,STACK	;SET STACK ADR
	CALL	COFF		;STOP ANY PRIOR ACTIVITY
	PRNT	MSG1		;SAY HELLO
	LXI	H,WRTCODE
	CALL	SQUIRT		;SET WRITE M/CODE
	MVI	A,1
	OUT	EXTCMD		;SLCT HEAD ZERO
	INR	A
	OUT	DRCSR		;ENB SECTOR/INDEX TO DATA BOARD
;
	CALL	TKZ		;RESTORE
	LXI	H,LDADR
	SHLD	DMADR		;INIT DMA ADR
	LXI	H,0
	SHLD	CYL		;INIT CYL ADR
	SHLD	HEAD		;INIT HEAD & SECTOR
	MVI	A,NSECT
	STA	SCNT		;NUM SECTS TO WRITE
;
;   PUT LOOP
;
LOOP:	MVI	A,DBENB
	OUT	CTCSR		;ENB DATA BFR
	XRA	A
	OUT	CTBFR		;SET BFR ADR = 0
	MOV	B,A		;B = COUNT (256)
	LHLD	DMADR		;ADR OF THE DATA
L1:	MOV	A,M
	OUT	CTDP		;PUT DATA INTO BFR
	INX	H
	DCR	B
	JNZ	L1
	SHLD	DMADR		;SAVE NEW DMA ADR
;
	LXI	H,WTBL
	CALL	DORW		;WRITE THE SECTOR
	LXI	H,SECTOR
	INR	M		;INCR SECTOR ADR
	MOV	A,M
	CPI	MAXSEC
	JC	L2		;JIF CON'T ON SAME TRACK
	MVI	M,0		;RESET SECTOR ADR
	DCX	H	
	INR	M		;INCR HEAD NR
	CALL	HDSEL		;SLCT NEW HEAD
	INX	H
;
L2:	INX	H		;H/L = 'SCNT'
	DCR	M		;DECR COUNT
	JNZ	LOOP		;JIF NOT DONE
;
	CALL	COFF		;TURN OFF DRIVE/CTLR
	PRNT	MSG2		;SAY GOODBYE
	IF	TEST
	JMP	DEBUG		;IF WE ARE TESTING
	ELSE
	JMP	WBOOT		;PUT DONE, EXIT
	ENDIF





;	---EXECUTE READ/WRITE COMMANDS---
;
;
DORW:	MOV	A,M
	STA	RETRY		;SET RETRY COUNT
	INX	H
	MOV	A,M
	OUT	CTCSR		;ENB CMP BFR
	INX	H
	MOV	A,M
	OUT	CTBFR		;SET CMP BFR ADR
	INX	H
	SHLD	CTA		;SAVE CMD TBL ADR
;
	LXI	H,CYL
	MVI	B,4
DO1:	MOV	A,M
	OUT	CTDP		;PUT HDR INFO INTO CMP BFR
	INX	H
	DCR	B
	JNZ	DO1
;
DO2:	CALL	RDY		;DRIVE READY ?  (RIF YES)
	LHLD	CTA		;CMD TBL ADR
	MOV	A,M		;A = CNTL BANK
	OUT	CTCSR		;SLCT CNTL BANK
	MOV	B,A
	INX	H
	MOV	A,M
	OUT	CTBFR		;SET START ADR
	INX	H
	MOV	A,B
	ORI	START
	OUT	CTCSR		;START R/W CMD
	LXI	H,0		;TIME-OUT DELAY COUNT
;
DO3:	IN	CTCSR		;CTLR STATUS
	RRC
	JC	DO4		;JIF DONE
	DCX	H		;DECR DELAY COUNT
	MOV	A,H
	ORA	L
	JNZ	DO3		;JIF CON'T WAITING
	OUT	CTCSR		;STOP THE CTLR
	JMP	DO5		;ABORT, TIME-OUT ERROR
;
DO4:	IN	CTCSR		;GET NON-CHANGING STATUS
	MOV	B,A		;   SAVE IT
	XRA	A
	OUT	CTCSR		;STOP CTLR
	MOV	A,B
	ANI	0EH		;TEST CTLR STATUS (0=OK)
	MOV	B,A
	IN	DRCSR		;DRIVE STATUS
	ANI	WRTFLT
	CNZ	CLRDF		;CIF CLEAR DRIVE FAULT
	ORA	B		;SET/CLEAR ERROR FLAG (0=OK)
	RZ			;RIF READ/WRITE OK
	LXI	H,RETRY
	DCR	M		;DECR RETRY CNT
	JNZ	DO2		;JIF RETRY READ/WRITE
; WRITE ERROR
DO5:	LXI	D,MSG5		;D/E = ADR OF ERROR MSG
	JMP	ERROR		;ABORT, READ ERROR




;	---RESTORE--
;
;
TKZ:	CALL	TZT		;TRACK ZERO TEST
	RZ			;RIF ALREADY AT TRACK ZERO
;
	LXI	H,511		;# CYLS WE CAN SEEK
	CALL	RTZ		;SEEK OUT
	RZ			;RIF AT TRACK 0
	LXI	H,LZONE+10-511
	CALL	RTZ		;TRY IT AGAIN
	RZ			;RIF FOUND TRACK ZERO THIS TIME
; RESTORE FAILED
	LXI	D,MSG4		;D/E = ADR OF ERR MSG
	JMP	ERROR		;ABORT, RESTORE FAILED
;
;   SEEK OUTWARD
;
RTZ:	CALL	RDY		;DRIVE READY ?  (RIF YES)
	MOV	A,L
	OUT	LOSC		;SET LSB OF SEEK COUNT
	MOV	A,H
	OUT	HISC		;SET MSB
	MVI	A,SKOUT
	OUT	EXTCMD		;SET SEEK DIRC = OUTWARD
	MVI	A,SKCMD
	OUT	DRCSR		;ISSUE SEEK CMD
	CALL	WSC		;WAIT FOR SEEK DONE
;
TZT:	IN	DRCSR		;DRIVE STATUS
	ANI	TK00		;TRACK ZERO INDICATOR
	XRI	TK00		;..MAKE IT LO-TRUE
	RET




;	---WAIT FOR SEEK COMPLETE---
;
;
WSC:	LXI	H,0		;TIME-OUT DELAY COUNT
	MVI	B,3		;..DITTO
;
WSC1:	IN	DRCSR		;DRIVE STATUS
	RAL
	RC			;RIF SEEK DONE
	DCX	H		;DECR DELAY COUNT
	MOV	A,H
	ORA	L
	JNZ	WSC1		;JIF CON'T WAITING
	DCR	B
	JNZ	WSC1
	LXI	D,MSG6		;D/E = ADR OF ERROR MSG
	JMP	ERROR		;ABORT, RESTORE FAILED TO FINISH




;	---DRIVE READY TEST---
;
;
RDY:	IN	DRCSR		;DRIVE STATUS
	ANI	READY		;DRIVE RDY BIT
	XRI	READY		;  MAKE IT LO-TRUE
	RZ			;RIF DRIVE RDY
	LXI	D,MSG3		;D/E = ADR OF ERROR MSG
	JMP	ERROR		;ABORT, DRIVE NOT RDY




;	---HEAD SELECT---
;
;
HDSEL:	LDA	HEAD
	RLC
	RLC			;SHIFT FOR H/L
	ORI	1		;TO MAINTAIN DRIVE SLCT
	OUT	EXTCMD		;SLCT NEW HEAD
	RET




;	---CLEAR DRIVE FAULT---
;
;
CLRDF:	XRA	A
	OUT	EXTCMD		;DE-SELECT THE DRIVE
	MVI	A,1
	OUT	EXTCMD		;RE-SELECT THE DRIVE
	RET




;	---WRITE COMMAND TABLE---
;
;
WTBL:	DB	5		;RETRY COUNT
	DB	5		;CMP BFR ENB
	DB	0E6H		;CMP BFR ADR
	DB	BANK1		;CNTL BANK
	DB	0D3H		;START ADR




;	---SQUIRT MICROCODE---
;
;
SQUIRT:	MOV	A,M
	OUT	CTCSR		;SLCT BANK
	INX	H
	MOV	A,M
	OUT	CTBFR		;SET CTLR BFR ADR
	INX	H
;
SQ1:	MOV	A,M
	ORA	A
	RZ			;RIF DONE
	INX	H		;INCR TBL ADR
	MOV	B,A		;B = COUNT
	RAL
	JC	SQ3		;JIF REPEAT
;
SQ2:	MOV	A,M
	OUT	CTDP		;OUTPUT CONTROL INFO
	INX	H
	DCR	B
	JNZ	SQ2
	JMP	SQ1		;DO NEXT STRING
;
SQ3:	ORA	A		;CLEAR CY
	RAR
	MOV	B,A		;B = COUNT
	MOV	A,M
	INX	H
SQ4:	OUT	CTDP		;OUTPUT REPEAT CONTROL INFO
	DCR	B
	JNZ	SQ4
	JMP	SQ1		;DO NEXT STRING




;	---WRITE MICROCODE---
;
;
WRTCODE	EQU	$		;  MS			06-09-81
;
	DB	1		
	DB	0D3H		
	DB	2,40H		
	DB	41H		
	DB	RPT+3,40H	
	DB	RPT+12,6DH	
	DB	1,63H		
	DB	RPT+4,65H	
	DB	RPT+2,67H	
	DB	2,49H		
	DB	40H		
	DB	RPT+17,50H	
	DB	5,5BH		
	DB	0DDH		
	DB	5DH		
	DB	50H		
	DB	0FH		
	DB	0		





;	---UNRECOVERABLE ERRORS---
;
;   UNRECOVERABLE ERRORS COME HERE WITH THE ADDRESS
;   OF AN ERROR MESSAGE IN H/L.
;
;
ERROR:	LXI	SP,STACK	;RESET STACK ADR
	CPM	F@PRT		;PRINT ERROR MSG
	CPM	F@CI		;WAIT FOR THE OPER
	CPI	3		;CNTL-C ?
	IF	TEST		;IF WE ARE TESTING
	CZ	TRAP		;TRAP TO DEBUG
	ELSE
	JZ	WBOOT		;ABORT 'PUT', WARM BOOT
	ENDIF
	PRNT	CRLF		;DO CR.LF
	JMP	LOOP		;TRY TO BOOT AGAIN



;	---TURN DRIVE/CONTROLLER OFF---
;
;
COFF:	XRA	A
	OUT	CTCSR		;STOP CTLR
	OUT	DRCSR		;TURN OFF INTERFACE
	OUT	EXTCMD		;DE-SELECT THE DRIVE
	RET




;	---MESSAGES---
;
;
MSG1:	DB	CR,LF,LF,LF
	DB	'MHPUT -- Vers 1.0',CR,LF
	DB	'16-Apr-83'
	DB	CR,LF,'$'
;
MSG2:	DB	CR,LF,LF
	DB	'System Written OK'
	DB	CR,LF,LF,'$'
;
MSG3:	DB	BELL,CR,LF,'* Drive not Ready $'
;
MSG4:	DB	BELL,CR,LF,'* Restore Failed $'
;
MSG5:	DB	BELL,CR,LF,'* Write Failed $'
;
MSG6:	DB	BELL,CR,LF,'* Time-Out Error $'
;
CRLF:	DB	CR,LF,'$'




;	---STORAGE---
;
;
DMADR:	DS	2		;DMA ADDRESS
CYL:	DS	2		;CYLINDER ADDRESS
HEAD:	DS	1		;HEAD NUMBER
SECTOR:	DS	1		;SECTOR ADDRESS
SCNT:	DS	1		;SECTOR COUNT
RETRY:	DS	1		;RETRY COUNT
CTA:	DS	2		;COMMAND TABLE ADRESS




	END
